# scientisttools : Python library for multidimensional analysis

## About scientisttools

**scientisttools** is a `Python` package dedicated to multivariate Exploratory Data Analysis, clustering analysis and discriminant analysis.

## Why use scientisttools?

* It performs **classical principal component methods** : 
    * Principal Components Analysis (PCA)
    * Principal Components Analysis with partial correlation matrix (PartialPCA)
    * Exploratory Factor Analysis (EFA)
    * Classical Multidimensional Scaling (CMDSCALE)
    * Metric and Non - Metric Multidimensional Scaling (MDS)
    * Correspondence Analysis (CA)
    * Multiple Correspondence Analysis (MCA)
    * Factor Analysis of Mixed Data (FAMD)
    * Multiple Factor Analysis (MFA)
    * Multiple Factor Analysis for qualitatives/categoricals variables (MFAQUAL)
    * Multiple Factor Analysis of Mixed Data (MFAMIX)
    * Multiple Factor Analysis of Contingence Tables (MFACT)

* In some methods, it allowed to **add supplementary informations** such as supplementary individuals and/or variables.
* It provides a geometrical point of view, a lot of graphical outputs.
* It provides efficient implementations, using a scikit-learn API.

Those statistical methods can be used in two ways :
* as descriptive methods ("datamining approach")
* as reduction methods in scikit-learn pipelines ("machine learning approach")

`scientisttools` also performs `clustering analysis`

* **Clustering analysis**:
    * Hierarchical Clustering on Principal Components (HCPC)
    * Variables Hierarchical Clustering Analysis (VARHCA)
    * Variables Hierarchical Clustering Analysis on Principal Components (VARHCPC)
    * Categorical Variables Hierarchical Clustering Analysis (CATVARHCA)


Notebooks are availabled.

## Installation

### Dependencies

scientisttools requires 

```
numpy>=1.26.2
matplotlib>=3.5.3
scikit-learn>=1.2.2
pandas>=1.5.3
mapply>=0.1.21
plotnine>=0.10.1
plydata>=0.4.3
pingouin>=0.5.3
scientistmetrics>=0.0.3
ggcorrplot>=0.0.2
```

### User installation

You can install scientisttools using `pip` :

```
pip install scientisttools
```

Tutorial are available

## Author

Duvérier DJIFACK ZEBAZE ([duverierdjifack@gmail.com](duverierdjifack@gmail.com))

library(FactoMineR)
data(tea)
res.mca = MCA(tea, ncp=20, quanti.sup=19, quali.sup=c(20:36), graph=FALSE)

res.hcpc = HCPC(res.mca,graph = F)


table(res.hcpc$data.clust$clust)

res.hcpc$desc.var$test.chi2

res.hcpc$desc.var$category$`1`
res.hcpc$desc.var$category$`2`

res.hcpc$desc.axes$quanti.var



aux4 <- min(phyper(round(Table[j,k],0)-1,round(marge.li[j],0),round(sum(marge.li),0)-round(marge.li[j],0),round(marge.col[k],0))*2+dhyper(round(Table[j,k],0),round(marge.li[j],0),round(sum(marge.li),0)-round(marge.li[j],0),round(marge.col[k],0)),
            phyper(round(Table[j,k],0),round(marge.li[j],0),round(sum(marge.li),0)-round(marge.li[j],0),round(marge.col[k],0),lower.tail=FALSE)*2+dhyper(round(Table[j,k],0),round(marge.li[j],0),round(sum(marge.li),0)-round(marge.li[j],0),round(marge.col[k],0)))

################################################################################
# PCA with wine dataset
################################################################################

# Multiple Factor Analysis
rm(list = ls())
library(FactoMineR)
library(factoextra)
data(wine)

res.pca <- PCA(wine,quanti.sup = 30:31,quali.sup = 1:2,graph = F)

############ Eigenvalues
head(res.pca$eig)

################ Individuals informations
ind <- get_pca_ind(res.pca)
head(ind$coord)
head(ind$cos2)
head(ind$contrib)
head(ind$dist)

############## Variables informations
res.var <- get_pca_var(res.pca)
head(res.var$coord)
head(res.var$cor)
head(res.var$cos2)
head(res.var$contrib)

pcobj <- res.pca
nobs.factor <- sqrt(nrow(pcobj$call$X))
d <- unlist(sqrt(pcobj$eig)[1])
u <- sweep(pcobj$ind$coord, 2, 1 / (d * nobs.factor), FUN = '*')
v <- sweep(pcobj$var$coord,2,sqrt(pcobj$eig[1:ncol(pcobj$var$coord),1]),FUN="/")
choices <- c(1,2)
scale=1
obs.scale = 1 - scale
df.u <- as.data.frame(sweep(u[,choices], 2, d[choices]^obs.scale, FUN='*'))

################ Supplementary elemenet
quanti_sup <- res.pca$quanti.sup
head(quanti_sup$coord)
head(quanti_sup$cor)
head(quanti_sup$cos2)

################## Supplementary qualitatives
quali_sup <- res.pca$quali.sup
head(quali_sup$coord)
head(quali_sup$cos2)
head(quali_sup$v.test)
head(quali_sup$dist)
head(quali_sup$eta2)


###############################################
# HCPC with wine
####################################################"
res.hc <- HCPC(res.pca,graph = F)

res.hc$desc.var$test.chi2
res.hc$desc.var$category

#################################################################"
# Muliple Factor Analysis for Contingency Tables (MFACT)
#################################################################

###Example with groups of frequency tables
rm(list = ls())
library(FactoMineR)
data(mortality)
res<-MFA(mortality,group=c(9,9),type=c("f","f"),
         name.group=c("1979","2006"),graph = FALSE)

############################################################
# Separates Analysis
###########################################################

res$separate.analyses

#########################################################
#  Row informations
#########################################################

row_infos <- get_mfa_ind(res)
round(row_infos$coord,3)
row_infos$contrib
row_infos$cos2
row_infos$coord.partiel
row_infos$within.inertia
row_infos$within.inertia
row_infos$within.partial.inertia


res$freq$coord
res$freq$contrib
res$freq$cos2


res$global.pca$eig
res$global.pca$var$coord

row_w = res$call$row.w
col_w = res$call$col.w
X <- res$global.pca$call$X
D = diag(row_w)
M = diag(col_w)

A = t(X)%*%D
A = A%*%as.matrix(X)
A = A%*%as.matrix(M)


s_v_d <- eigen(A)

##### Script pour les chapitres 4, 5 et 7 - AFM - Données : jus d'orange (idem chap. 1) 

################################ Chapitre 4 ################################
library(FactoMineR)

orange=read.table("./donnee/Orange5.csv",sep=";",dec=",",header=TRUE,row.names=1)
attributes(orange[,1:17])

# Sélection des variables utilisées en AFM (le même fichier est utilisé ensuite avec plus de variables) 
orange1=orange[,3:18]
attributes (orange1)

ResAFM=MFA(orange1,group=c(8,7,1),type=c("s","s","s"),name.group=c("Chimie","Sensoriel","Appréciation_globale"),num.group.sup=3)

# Graphiques 
plot(ResAFM,choix="ind",hab="group",cex=1.2)
x11()
plot(ResAFM,choix="var",cex=1.2)
x11()
plot(ResAFM,choix="axes")
x11()
plot(ResAFM,choix="group",cex=1.2)

# Ecriture des tableaux de résultats dans un fichier .csv
write.infile(ResAFM,file="ResAFM.csv")

# Diagramme des valeurs propres
barplot(ResAFM$eig[,1],names=1:5)

#### Tableau 4.5

# Initialisation
tab4_5=matrix(nrow=8,ncol=5)

# Noms des lignes et des colonnes
row.names(tab4_5)=c("ACP Chimie","ACP Sensoriel","ACP Ensemble"," Groupe Chimie"," Groupe Sensoriel","AFM"," Groupe Chimie"," Groupe Sensoriel")
colnames(tab4_5)=c("Inertie totale","F1","F2","F1%","F2%")

# Les cinq premiers éléments de la colonne 1
tab4_5[1:5,1]=c(8,7,15,8,7)

# Les lignes (3,4,5), relatives à l'ACP sur les 15 variables, nécessitent d'exécuter cette ACP
resPCA=PCA(orange1[,1:15])

# Ligne 3 : valeurs propres de l'ACP (dans resPCA$eig)
tab4_5[3,2:5]=c(t(resPCA$eig[1:2,1]),t(resPCA$eig[1:2,2]))

# Lignes 4 et 5, colonnes 4 et 5. Les contributions des variables sont dans resPCA$var$contrib ; il faut les additionner par groupe.
tab4_5[4,4:5]=apply(resPCA$var$contrib[1:8,1:2],MARGIN=2,FUN=sum)
tab4_5[5,4:5]=apply(resPCA$var$contrib[9:15,1:2],MARGIN=2,FUN=sum)

# Lignes 4 et 5, colonnes 2 et 3. On retrouve l'inertie en multipliant la contribution (en %) par la valeur propre correspondante.
tab4_5[4:5,2]=tab4_5[4:5,4]*resPCA$eig[1,1]/100
tab4_5[4:5,3]=tab4_5[4:5,5]*resPCA$eig[2,1]/100

# Les ACP séparées des groupes (lignes 1 et 2) sont éditées via l'AFM dans ResAFM$separate.analyses, les valeurs propres étant dans ...$eig.
tab4_5[1,2:5]=c(t(ResAFM$separate.analyses$Chimie$eig[1:2,1]),t(ResAFM$separate.analyses$Chimie$eig[1:2,2]))
tab4_5[2,2:5]=c(t(ResAFM$separate.analyses$Senso$eig[1:2,1]),t(ResAFM$separate.analyses$Senso$eig[1:2,2]))

# Ligne 6. Les valeurs propres de l'AFM sont dans ResAFM$eig.
tab4_5[6,2:5]=c(t(ResAFM$eig[1:2,1]),t(ResAFM$eig[1:2,2]))

# Lignes 6, 7, 8, colonne 1. L'inertie globale d'un groupe dans l'AFM résulte directement du nombre de variables (les variables sont réduites) et de la pondération (par la première valeur propre).
tab4_5[7:8,1]=tab4_5[1:2,1]/tab4_5[1:2,2]
tab4_5[6,1]=tab4_5[7,1]+tab4_5[8,1]

# Lignes 7 et 8. Les inerties des variables sommées par groupe sont dans ResAFM$group ; les inertie brutes sont dans coord (l'explication de ce terme apparaît au chapitre 8) et les pourcentages dans contrib.
tab4_5[7:8,2:3]=c(t(ResAFM$group$coord[,1]),t(ResAFM$group$coord[,2]))
tab4_5[7:8,4:5]=c(t(ResAFM$group$contrib[,1]),t(ResAFM$group$contrib [,2]))

# Pour l'édition, on réduit le nombre de chiffres décimaux.

tab4_5[,2:3]=round(tab4_5[,2:3],3)

tab4_5[,4:5]=round(tab4_5[,4:5],2)

tab4_5[1:5,1]=round(tab4_5[1:5,1],0)

tab4_5[6:8,1]=round(tab4_5[6:8,1],3)

tab4_5
write.infile(tab4_5,file="tab4_5.csv")
#
# Sorties simplifiées éditées dans le fichier SorAFM
summary(ResAFM,nbelements = Inf,file="SorAFM")
#


################################ Chapitre 5 ################################

plot.MFA(ResAFM)

# Obtenir le graphe des individus partiels de l'AFM
# Il est commode de faire apparaître les points partiels non étiquetés mais coloriés
# selon leur groupe (ici on explicite les valeurs par défaut des arguments axes et choix).
plot.MFA(ResAFM,axes=c(1,2),choix="ind",hab="group",partial="all")

# On peut restreindre la représentation des individus partiels à quelques individus
# dont on indique le libellé.
plot.MFA(ResAFM,axes=c(1,2),choix="ind",hab="group",partial=c("P1 Pampryl amb.","P2 Tropicana amb."))

# La sélection interactive des individus dont on souhaite la représentation des points
# partiels (présentée dans R Commander) est accessible directement via la fonction plotMFApartial.

plotMFApartial(ResAFM,axes=c(1,2),hab="group")

# Cette commande affiche la représentation des individus moyens. On clique sur
# les points à sélectionner (un second clic annule la sélection). Attention, toujours
# arrêter explicitement la sélection (clic droit ou onglet en haut à gauche) avant de
# réaliser une autre opération.

# L'étiquetage des points partiels se fait en concaténant le libellé de l'individu et le
# libellé du groupe. Il en résulte un graphique encombré. Exemple :
plot(ResAFM,choix="ind",partial="all",lab.par=T,hab="group")

# Une option consiste à afficher des libellés spécifiques d'un graphique. Pour cela,
# on affiche d'abord un graphique sans libellés ; dans la fenêtre active obtenue, on
# ajoute des libellés à l'aide de la fonction text. Exemple pour un graphique en noir
# et blanc (habillage="none") :
plot(ResAFM,choix="ind",partial="all",hab="none")
text(ResAFM$ind$ coord.partiel[,1],ResAFM$ind$ coord.partiel[,2],rep(c("Chim","Senso"),6),pos=3,offset=0.5 )

# Les sorties de l'AFM comportent un grand nombre de tableaux. Les données du
# tableau 5.1 sont dans resAFM$ind$within.inertia ; celles du tableau 5.2
# sont dans resAFM$inertia.ratio.

####################### Chapitre 7 ####################################

# Graphique de la représentation des groupes
plot.MFA(ResAFM,axes=c(2,3),choix="group")

#### Tableau 7.2 
# Initialisation
tab7_2=matrix(nrow=3,ncol=7)

# Noms des lignes et des colonnes
row.names(tab7_2)=c("W1","W2","NJ")
colnames(tab7_2)=c(paste("Axe",1:5),"Plan(1,2)","Ssp(1,5)")

# Qualité de représentation des groupes
tab7_2[1:2,1:5]=ResAFM$group$cos2[,1:5]

# Inertie projetée de NJ
tab7_2[3,1:5]=apply(ResAFM$group$coord[,1:5]^2,MARGIN=2,FUN=sum)

# Qualité de réprésentation de NJ
# L'inertie totale des Wj est dans ResAFM$group$dist2
tab7_2[3,1:5]=tab7_2[3,1:5]/sum(ResAFM$group$dist2)

# Deux marges colonnes
tab7_2[,6]=apply(tab7_2[1:3,1:2],MARGIN=1,FUN=sum)
tab7_2[,7]=apply(tab7_2[1:3,1:5],MARGIN=1,FUN=sum)

round(tab7_2,4)
#
############# Données : couleur & forme
#
# Lecture et vérification
#
CouleurForme=read.table("Couleur&Forme.csv",header=TRUE,sep=";",dec=".",row.names=1)
CouleurForme
#
# Figure 7.4 (b)
#
res=MFA(CouleurForme,group=c(2,2),type=c("c","c"),graph=F,name.group=c("G1","G2"))
plot(res,choix="group",cex=1.3)
points(1,res$eig[2,1]/res$eig[1,1],pch=16,cex=1.3)
text( 1,res$eig[2,1]/res$eig[1,1],"moyen(AFM)",offset=0.5,pos=3,cex=1.3)

#
############# Données : deux trapèzes (chapitre 5)
#
library(FactoMineR)
trapeze=read.table("DonTrapezes.csv",sep=";",dec=",",header=TRUE,row.names=1)
ResAFM=MFA(trapeze,group=c(2,2),type=c("c","c"),name.group=c("G1","G2"))
#
# Figure 5.7 à gauche
#
coord=rbind(ResAFM$ind$coord[,1:2],ResAFM$ind$coord.partiel[,1:2])
colnames(coord)=c(paste("Dim",1:2,"(",ResAFM$eig[1:2,2],"%)",sep=""))
ylimax= max(coord[,1] ,na.rm=TRUE)+0.5
ylimin= min(coord[,1] ,na.rm=TRUE)-0.5
plot(coord[1:4,1:2],ylim=c(ylimin,ylimax))
text(coord[1:2,1],coord[1:2,2],rownames(coord)[1:2],pos=1,offset=0.5)
text(coord[3:4,1],coord[3:4,2],rownames(coord)[3:4],pos=3,offset=0.5)
abline(v=0)
abline(h=0)
list=c(1:4,1)
points(coord[list,1],coord[list,2],type="o")
#
# Figure 5.7 à droite
#
xlimax=max(coord[,2] ,na.rm=TRUE)+0.5
xlimin=min(coord[,2] ,na.rm=TRUE)-0.5
plot(coord[,1:2],ylim=c(ylimin,ylimax),xlim=c(xlimin,xlimax))
listegauche=c(1,4:6,11,12)
listedroite=c(2:3,7:10)
text(coord[listegauche,1],coord[listegauche,2],rownames(coord)[listegauche],pos=2,offset=0.5)
text(coord[listedroite,1],coord[listedroite,2],rownames(coord)[listedroite],pos=4,offset=0.5)
abline(v=0)
abline(h=0)
list=c(6,8,10,12,6)
points(coord[list,1],coord[list,2],type="o")
list=c(5,7,9,11,5)
points(coord[list,1],coord[list,2],type="o")
#

#################################################################
# HCPC on decathlon2
#################################################################

rm(list = ls())
library("FactoMineR")
library(factoextra)

# PCA
res.pca <- PCA(decathlon2, ind.sup = 24:27, 
               quanti.sup = 11:12, quali.sup = 13, graph=FALSE)

res.hc <- HCPC(res.pca,nb.clust = 3,graph = F)

#####

clust <- res.hc$data.clust$clust

# Variables descriptions
desc_var <- res.hc$desc.var
desc_var$quanti.var
desc_var$quanti
desc_var$call

#### Axis description
desc_axes <- res.hc$desc.axes
desc_axes$quanti.var
desc_axes$quanti
desc_axes$call

ind <- res.hc$desc.ind
ind$para
ind$dist

consolidation <- function(X, clust, iter.max = 10, ...) {
  centers <- NULL
  centers <- by(X, clust, colMeans)
  centers <- matrix(unlist(centers), ncol = ncol(X), byrow = TRUE)
  km <- kmeans(X, centers = centers, iter.max = iter.max, ...)
  return(km)
}


X <- res.pca$ind$coord
clust <- res.hc$data.clust$clust
cons <- consolidation(X,clust)

cons$cluster
cons$centers
cons$size
cons$totss
cons$withinss
cons$betweenss

sum(cons$withinss)

km <- kmeans(X)

url = "D:/Bureau/PythonProject/packages/scientisttools/scientisttools/data"
data <- readxl::read_excel(paste0(url,"/temperature.xlsx"))
data <- data %>% tibble::column_to_rownames(var="Villes")

res.pca = PCA(data)
res.hc <- HCPC(res.pca,nb.clust = 3,graph=F)

fviz_cluster(res.hc)

res.hc$desc.var$quanti.var
res.hc$desc.var$quanti

res.hc$desc.ind$para

library(FactoMineR)

# https://openclassrooms.com/fr/courses/5641796-adoptez-visual-studio-comme-environnement-de-developpement/6140631-utilisez-les-raccourcis-pour-etre-plus-efficace

races_canines <- readxl::read_excel("./donnee/races_canines_acm.xlsx")
races_canines <- tibble::column_to_rownames(races_canines,var = "Chien")

# MCA with all informations
res.mca <- MCA(races_canines, ind.sup = 28:33, 
               quanti.sup = 8, quali.sup = 7,  graph=FALSE)
print(res.mca)
res.mca.shiny <- MCAshiny(res.mca)

head(res.mca$ind.sup$coord)

head(res.mca$var$contrib)
head(res.mca$var$eta2)

# Supplementary variables/categories
head(res.mca$quali.sup$coord)
head(res.mca$quali.sup$cos2)
head(res.mca$quali.sup$v.test)
head(res.mca$quali.sup$eta2)

# Supplementary continuous variables - Coordinates
head(res.mca$quanti.sup$coord)

# Supplementary Individuals
head(res.mca$ind.sup$coord)
head(res.mca$ind.sup$cos2)

res.mca <- MCA(poison, ind.sup = 53:55, 
               quanti.sup = 1:2, quali.sup = 3:4,  graph=FALSE)
summary(res.mca)
dimdesc(res.mca)

res = catdes(tea, num.var=23, proba=0.05)
res$test.chi2
res$category


anova(res.mca$ind$coord[,1]~tea[,1])

library(FactoMineR)
women_work=read.table("http://factominer.free.fr/classical/datasets/women_work.txt", header=TRUE, row.names=1, sep="\t")
res.ca = CA(women_work, col.sup=4:ncol(women_work))

library("FactoMineR")
library(Factoshiny)
library(factoextra)
res.ca <- CA(housetasks, graph = FALSE)
res.shiny = CAshiny(res.ca)
dimdesc(res.ca)
# PCA
data("decathlon2")
decathlon2.active <- decathlon2[1:23, 1:10]
res.pca <- PCA(decathlon2, ind.sup = 24:27, 
               quanti.sup = 11:12, quali.sup = 13, graph=FALSE)

# Supplementary quantitatives informations.
head(res.pca$quanti.sup$coord)
head(res.pca$quanti.sup$cor)
head(res.pca$quanti.sup$cos2)

# Supplementary qualitatives informations
head(res.pca$quali.sup$coord)
head(res.pca$quali.sup$cos2)
head(res.pca$quali.sup$v.test)
head(res.pca$quali.sup$eta2)
head(res.pca$quali.sup$dist)

# Supplementary individuals informations
head(res.pca$ind.sup$coord)
head(res.pca$ind.sup$cos2)
head(res.pca$ind.sup$dist)

p = dimdesc(res.pca)
res.shiny = PCAshiny(res.pca)

model1 <- PCA(decathlon2.active,graph=FALSE)
model2 <- PCA(decathlon2,ind.sup=24:27,quali.sup = 13,graph=FALSE)
model3 <- PCA(decathlon2,quanti.sup = 11:12, quali.sup = 13, graph=FALSE)
model4 <- PCA(decathlon2, ind.sup = 24:27, 
              quanti.sup = 11:12, quali.sup = 13, graph=FALSE)
res.shiny = PCAshiny(model4)

X.quanti.sup <- model4$call$quanti.sup
row.w <- model4$call$row.w
dist2 <- as.vector(crossprod(rep(1,nrow(X.quanti.sup)),as.matrix(X.quanti.sup^2*row.w)))

as.matrix(X.quanti.sup^2*row.w)

row_coord <- cbind.data.frame(res.pca$ind$coord[,c(1,2)],
                       Competition=decathlon2[(1:23),13])
df <- row_coord
find_hull <- function(row_coord){
  row_coord[chull(row_coord$Dim.1,row_coord$Dim.2),]
}
hulls <- plyr::ddply(df,"Competition",find_hull)


fig <- ggplot(row_coord,aes(x=Dim.1,y=Dim.2,colour=Competition,fill=Competition))+
  geom_point()+
  geom_polygon(data = hulls,alpha=0.5)


fviz_pca_ind(res.pca,
             habillage = "Competition",
             addEllipses =TRUE, ellipse.type = "confidence",
             palette = "jco", repel = TRUE)


library("FactoMineR")
data(wine)
df <- wine[,c(1,2, 16, 22, 29, 28, 30,31)]
head(df[, 1:7], 4)

library(FactoMineR)
res.famd <- FAMD(df, graph = FALSE)
res.pca <- FAMDshiny(res.famd)
dimdesc(res.famd)
fviz_contrib(res.famd,choice = "ind")

require(FactoMineR)
data(geomorphology)
# FAMD with Factoshiny:
res.shiny=FAMDshiny(geomorphology)

# Find your app the way you left it (by clicking on the "Quit the app" button)
res.shiny2=FAMDshiny(res.shiny)

library(FactoMineR)
data(tea)
res.hcpc = HCPC(res.mca)
res.shiny = HCPCshiny(res.hcpc)

res.hcpc$desc.var$test.chi2
res.hcpc$desc.var$category
dimdesc(res.hcpc)

# Multiple Factor Analysis
library(FactoMineR)
library(factoextra)
data(wine)
res.mfa <- MFA(wine, 
               group = c(2, 5, 3, 10, 9, 2), 
               type = c("n", "s", "s", "s", "s", "s"),
               name.group = c("origin","odor","visual",
                              "odor.after.shaking", "taste","overall"),
               num.group.sup = c(1, 6),
               graph = FALSE)


res.shiny = MFAshiny(res.mfa)

# Separate analyses
res.mfa$separate.analyses$origin
res.mfa$separate.analyses$odor
res.mfa$separate.analyses$visual
res.mfa$separate.analyses$odor.after.shaking
res.mfa$separate.analyses$taste
res.mfa$separate.analyses$overall

##########################################################
# Individuals Results
##########################################################

# Individuals
ind <- get_mfa_ind(res.mfa)
head(ind$coord)
head(ind$contrib)
head(ind$cos2)
head(ind$coord.partiel)

### à compléter
head(ind$within.inertia)
head(ind$within.partial.inertia)



###########################################################"
# Actives continues variables
#########################################################

# Quantitative Variables
quanti.var <- get_mfa_var(res.mfa, "quanti.var")
# Coordinates
head(quanti.var$coord)
head(quanti.var$cos2)
head(quanti.var$contrib)
head(quanti.var$cor)

#### Supplementary continues variables
quanti.var.sup <- res.mfa$quanti.var.sup
head(quanti.var.sup$coord)
head(quanti.var.sup$cos2)
head(quanti.var.sup$cor)

########################################################
#  Group informations
########################################################

# Group of variables
group <- get_mfa_var(res.mfa, "group")
group$coord
group$contrib
group$Lg
group$RV
group$correlation

# A chercher
group$dist2
group$cos2

### Supp group
group$coord.sup # trouver
group$cos2.sup
group$dist2.sup


summary(res.mfa)

res.mfa$eig
res.mfa$separate.analyses
res.mfa$group$Lg
res.mfa$group$RV

#############################################################
# Partial axes
##############################################################
head(res.mfa$partial.axes$coord)
head(res.mfa$partial.axes$cor)
head(res.mfa$partial.axes$contrib)
dim(res.mfa$partial.axes$cor.between)

fviz_mfa_axes(res2.mfa)

####################" Inertia
res.mfa$inertia.ratio

res.mfa$call$col.w



################################################################
# Supplementary elements
##############################################################"

# Supplementary continue variables
res.mfa$quanti.var.sup$coord
res.mfa$quanti.var.sup$cos2
res.mfa$quanti.var.sup$cor

# Supplementary qualitatives variables
res.mfa$quali.var.sup$coord
res.mfa$quali.var.sup$cos2
res.mfa$quali.var.sup$v.test
res.mfa$quali.var.sup$coord.partiel
# A compléter
res.mfa$quali.var.sup$within.inertia
res.mfa$quali.var.sup$within.partial.inertia

########################## Result summary

res.mfa$summary.quanti
res.mfa$summary.quali

res.mfa.pca <- res.mfa$global.pca

###################### Discriminant Multiple Analysis
library(TExPosition)
race <- read.csv("./donnee/races_canines.txt",sep = "\t",header =TRUE,row.names = )

race <- tibble::column_to_rownames(race,var = "Chien")

canines = list(data=PCAmixdata::tab.disjonctif.NA(race[,c(1:6)]),
               design = PCAmixdata::tab.disjonctif.NA(race[,7]))

disca <- tepDICA(DATA = canines$data,
                 DESIGN = canines$design,
                 make_design_nominal = FALSE,
                 graphs = FALSE)

texdata <- disca$TExPosition.Data
head(texdata$fii) # Factor scores
head(texdata$dii) # Squared distances
head(texdata$rii) # Cosinus of the individuals

head(texdata$eigs)

head(apply(texdata$fii,2,function(x){x^2}))


library("FactoMineR")
data(wine)
df <- wine[,c(1,2, 16, 22, 29, 28, 30,31)]
head(df[, 1:7], 4)
res.famd <- FAMD(df, graph = FALSE)
res.shiny <- FAMDshiny(res.famd)


# Confusion Matrix
library(caret)

# data/code from "2 class example" example courtesy of ?caret::confusionMatrix

lvs <- c("normal", "abnormal")
truth <- factor(rep(lvs, times = c(86, 258)),
                levels = rev(lvs))
pred <- factor(
  c(
    rep(lvs, times = c(54, 32)),
    rep(lvs, times = c(27, 231))),
  levels = rev(lvs))

confusionMatrix(pred, truth)

library(ggplot2)
library(dplyr)

table <- data.frame(confusionMatrix(pred, truth)$table)

plotTable <- table %>%
  mutate(goodbad = ifelse(table$Prediction == table$Reference, "good", "bad")) %>%
  group_by(Reference) %>%
  mutate(prop = Freq/sum(Freq))

# fill alpha relative to sensitivity/specificity by proportional outcomes within reference groups (see dplyr code above as well as original confusion matrix for comparison)
ggplot(data = plotTable, mapping = aes(x = Reference, y = Prediction, fill = goodbad, alpha = prop)) +
  geom_tile() +
  geom_text(aes(label = Freq), vjust = .5, fontface  = "bold", alpha = 1) +
  scale_fill_manual(values = c(good = "green", bad = "red")) +
  theme_bw() +
  xlim(rev(levels(table$Reference)))

################################################################################
# CA with children dataset
################################################################################

# Multiple Factor Analysis
rm(list = ls())
library(FactoMineR)
library(factoextra)

data(children)
children$group <- c(rep("A",4),rep("B",5),rep("C",5),rep("D",4))
res.ca <- CA (children, row.sup = 15:18, quanti.sup = 6:8,quali.sup = 9,graph = F)

############"" Eigenvalyes
res.ca$eig


############# Rows informations
rows = get_ca_row(res.ca)
head(rows$coord)
head(rows$contrib)
head(rows$cos2)
head(rows$inertia)


####################### Columns informations
cols = get_ca_col(res.ca)
head(cols$coord)
head(cols$contrib)
head(cols$cos2)
head(cols$inertia)


res.km <- kmeans(cols$coord, centers = 2, nstart = 25)
grp <- as.factor(res.km$cluster)
# Color variables by groups
fviz_ca_col(res.ca, col.var = grp, 
             palette = c("#0073C2FF", "#EFC000FF"),
             legend.title = "Cluster")

rm(list = ls())
library(FactoMineR)
library(factoextra)
data (poison)
res.mca <- MCA(poison,ind.sup = c(51:55),quanti.sup = c(1:2),quali.sup = c(3:4),graph = FALSE)


fviz_cos2(res.mca,choice = "quanti.sup")

res.mca$call$marge.col
res.mca$call$marge.row
res.mca$svd$vs
res.mca$svd$U
res.mca$svd$V

head(res.mca$ind$coord)

res.mca$quali.sup$eta2

res.mca$quanti.sup$coord

head(res.mca$var$coord)
unique(poison$Sick)
unique(poison$Sex)


data(geomorphology)
res <- FAMD(geomorphology,graph = FALSE)

head(res$quanti.var$coord)
head(res$var$coord)




get_mca_var(res.mca)
x = get_mca(res.mca,element = "quanti.sup")
x = get_mca_var(res.mca,element = "quanti.sup")
x = get_mca_var(res.mca,element = "mca.cor")


fviz_mca_var(res.mca,choice = "quanti.sup")

###############################################
# HCPC with poison
####################################################"
res.hc <- HCPC(res.mca,graph = F)

desc_var <- res.hc$desc.var
desc_var$test.chi2
desc_var$category
desc_var$quanti.var
desc_var$quanti


X <- res.mca$ind$coord
clust <- res.hc$data.clust$clust

centers <- by(X, clust, colMeans)
centers <- matrix(unlist(centers), ncol = ncol(X), byrow = TRUE)

df <- cbind.data.frame(X,clust)

df %>% group_by(clust) %>% 
  summarise(across(
    .cols = is.numeric, 
    .fns = mean, na.rm = TRUE
  ))

library(ggplot2)
library(ggdendro)
model <- hclust(dist(USArrests), "ave")
dhc <- as.dendrogram(model)
# Rectangular lines
ddata <- dendro_data(dhc, type = "rectangle")

p <- ggplot(segment(ddata)) + 
  geom_segment(aes(x = x, y = y, xend = xend, yend = yend)) + 
  coord_flip() + 
  scale_y_reverse(expand = c(0.2, 0))
p

#################################################################
# AFM sur Données Mixtes
#################################################################

#### Script pour le chapitre 8 - AFM sur données mixtes - Données : biométrie2
rm(list = ls())
library(FactoMineR)

Biometrie2=read.table("donnee/Biometrie2.csv",header=TRUE,sep=";",dec=".",row.names=1)

colnames(Biometrie2)

# L'AFM est réalisée sur les seules six premières colonnes avec toutes les options par défaut

res=MFA(Biometrie2,group=c(3,3,3,3),
        type=c("n","s","n","s"),
        #num.group.sup = c(3,4),
        graph = FALSE)

fviz_contrib(res,choice = "quanti.var")

fviz_mfa_ind(res)
fviz_mfa_var(res)
fviz_mfa_axes(res)

####################################################
# Eigenvalues informations
########################################################
res$eig

#######################################################
# Individuals informations
#######################################################
res$ind$coord
res$ind$cos2
res$ind$contrib
res$ind$coord.partiel
res$ind$within.inertia
res$ind$within.partial.inertia

#########################################################
# Variables Informations
##########################################################
quanti_var <- get_mfa_var(res,"quanti.var")
quanti_var$coord
quanti_var$cor
quanti_var$cos2
quanti_var$contrib

###############################################################
# Qualitatives informations
###############################################################
quali_var <- get_mfa_var(res,"quali.var")
quali_var$coord
quali_var$cos2
quali_var$contrib
quali_var$v.test
quali_var$coord.partiel
quali_var$within.inertia
quali_var$within.partial.inertia

#############################################################
# Group informations
###############################################################
group <- get_mfa_var(res,"group")
head(group$coord)
head(group$contrib)
head(group$correlation)
head(group$Lg)
head(group$RV)
head(group$dist2) 
head(group$cos2)

x <- group$Lg[c(1,2),c(1,2)]

res$group$coord.sup
res$group$cos2.sup
res$group$dist2.sup

#############################################################
# Partial axes
##############################################################
partial_axes <- get_mfa_partial_axes(res)
partial_axes$coord
partial_axes$cor
partial_axes$contrib
partial_axes$cor.between

################################################################
# Inertia Informations
################################################################
res$inertia.ratio

# Figure 8.1 à droite
varco<-res$quali.var$coord
plot.MFA(res,choix="ind",hab="group")
points(varco[1:3,1],varco[1:3,2],type="o")
points(varco[6:8,1],varco[6:8,2],type="o")

# Etiqueter les individus partiels et/ou les modalités partielles, avec des noms de groupes choisis :
res=MFA(Biometrie2[,1:6],group=c(3,3),type=c("n","s"),name.group=c("Classes","CR"))
plot.MFA(res,axes=c(1,2),choix="ind",habillage="group",invisible="quali",partial="all",lab.par=TRUE)

### Graphe des modalités - figure 8.2
plot.MFA(res,axes=c(1,2),choix="ind",habillage="group",invisible="ind",partial="all")
# Etiqueter les points partiels par les noms des groupes
text(res$quali.var$coord.partiel[seq(1,15,2),1],res$quali.var$coord.partiel[seq(1,15,2),2],rep("CR",6),pos=3,offset=0.5)
text(res$quali.var$coord.partiel[seq(2,16,2),1],res$quali.var$coord.partiel[seq(2,16,2),2],rep("Classes",6),pos=1,offset=0.5)
# Relier les points moyens des modalités des variables Longueur et Largeur
points(varco[1:3,1],varco[1:3,2],type="o")
points(varco[6:8,1],varco[6:8,2],type="o")

### Colorier les individus en fonction de leur modalité pour la variable 2
plot.MFA(res,choix="ind",invisible="quali",hab=2)

### Afficher des ellipses de confiance autour des modalités de la variable 2
plotellipses(res,keepvar=2)

### Figure 8.3
# Individus et modalités sur plan 1 3
plot.MFA(res,choix="ind",axes=c(1,3),hab="group")
points(varco[1:3,1],varco[1:3,3],type="o")
points(varco[6:8,1],varco[6:8,3],type="o")

# Carré des liaisons 
res=MFA(Biometrie2,group=c(3,3,rep(1,6)),type=c("n","s",rep("n",3),rep("s",3)),num.group.sup=c(3:8),name.group=c("G1qualitatif","G2quantitatif","LongQuali","PoidQuali","LargQuali","LongQuanti","PoidQuanti","LargQuanti"),graph = F)

### Tableau 8.5 (corrélations entre axes partiels)
round(res$partial.axes$cor.between[6:8,1:3],2)

### Tableau 8.8 (qualités de représentation dans RI2 ; avec des libellés un peu abrégés)
# Initialisation et choix des libellés
tab_8.8=matrix(nrow=9,ncol=3)
row.names(tab_8.8)=c("Groupe 1","Groupe 2","Ensemble","LongQuali","PoidQuali","LargQuali","LongQuanti","PoidQuanti","LargQuanti")
colnames(tab_8.8)=c("F1","F2","F3")
# Les cos2 des Wj sont calculés par l'AFM (cos2 et cos2.sup).
tab_8.8[1:2,1:3]=res$group$cos2[,1:3]
tab_8.8[4:9,1:3]=res$group$cos2.sup[,1:3]
# Le rapport (pour NJ) inertie projetée/inertie totale doit être recalculé à partir des coordonnées (coord)
# et des distances des Wj à l'origine (dist2)
tab_8.8[3,1:3]= apply(res$group$coord[,1:3]^2,MARGIN=2,FUN=sum)
tab_8.8[3,1:3]=tab_8.8[3,1:3]/sum(res$group$dist2)
# Edition avec deux chiffres décimaux
round(tab_8.8,2)

### Tableau 8.9 (indicateurs de liaison Lg et RV )
# Initialisation et choix des libellés
tab8_9=matrix(nrow=2,ncol=3)
row.names(tab8_9)=c("Lg","RV")
colnames(tab8_9)=c("Longueur","Poids","Largeur")
# On récupère les coefficients sur les diagonales # des matrices res$group$Lg et res$group$RV
tab8_9[1,1:3]<-diag(res$group$Lg[3:5,6:8] )
tab8_9[2,1:3]<- diag(res$group$RV[3:5,6:8] )
# Edition avec trois chiffres décimaux
round(tab8_9,3)

### Tableau 8.7
# Initialisation
Tab8_7=matrix(rep(0,78),nrow=13,ncol=6)
# BCR Groupe quantitatif centré et réduit
# Bdis : groupe qualitatif sous forme disjonctive complète
BCR=as.matrix(scale(Biometrie2[,4:6])*sqrt(6/5))
Bdis=tab.disjonctif(Biometrie2[,1:3])
colnames(Tab8_7)=rownames(Biometrie2)
rownames(Tab8_7)=c(colnames(BCR),"Ind.part.quanti",colnames(Bdis),"Ind.part.quali")

# Premières valeurs propres de l'AFM et des analyses séparées
L1AFM=res$eig[1,1]
L1ACM=res$separate.analyses$G1qualitatif$eig[1,1]
L1ACP=res$separate.analyses$G2quantitatif$eig[1,1]

# coeff=coefficient dans la relation de transition
coord=res$quanti.var$coord[,1]
coeff=2/(sqrt(L1AFM)*L1ACP)

# Partie groupe quantitatif
for(i in 1:3){ for(j in 1:6) {
  Tab8_7[i,j]=BCR[j,i]*coord[i]*coeff
  Tab8_7[4,j]=Tab8_7[4,j]+Tab8_7[i,j]
}}

# Partie groupe qualitatif
coeff=2/(L1AFM*L1ACM*3)
coord=res$quali.var$coord[,1]
for(i in 1:8){for(j in 1:6) {
  Tab8_7[i+4,j]=Bdis[j,i]*coord[i]*coeff
  Tab8_7[13,j]=Tab8_7[13,j]+Tab8_7[i+4,j]
}}

rm(list = ls())
library(FactoMineR)
data("children")

data(housetasks)
# res.ca <- CA(housetasks, graph=FALSE)
children$group <- c(rep("A",5),rep("B",5),rep("C",4),rep(NA,4))
res.ca <- CA (children,row.sup = 15:18,
              quanti.sup = 6:8,quali.sup = 9,graph = FALSE)

X.del <- as.data.frame(res.ca$call$X)
Xtot2 <- res.ca$call$Xtot[-c(15:18),]
quali.sup<- c("group")
X.quali.sup <- Xtot2[,quali.sup]
for (j in 1:length(quali.sup)) {
  Xtot2[,quali.sup[j]] <- droplevels(Xtot2[,quali.sup[j]] , reorder=FALSE)
  print(Xtot2)
  X.quali.sup <- rbind(X.quali.sup, matrix(unlist(by(X.del, 
                                                     Xtot2[, quali.sup[j]], colSums)), ncol = ncol(X.del), byrow = T))
}

matrix(unlist(by(X.del,Xtot2[, quali.sup[1]], colSums)),ncol = ncol(X.del), byrow = T)

res.ca$call$marge.col
res.ca$call$row.w

X <- as.data.frame(t(children))
res.ca <- CA (X,row.sup = 6:8,col.sup = c(15:18),graph = F)




svd_trip = svd.triplet(X,row.w = )

res.ca$svd$vs
res.ca$svd$U
res.ca$svd$V

X <- res.ca$call$X
row.w <- rep(1,nrow(X))
X.row.sup <- children[c(15:18),c(1:5)]
somme.row <- rowSums(X.row.sup)
X.row.sup <- X.row.sup/somme.row

marge.col <- res.ca$call$marge.col

dist2.row <- rowSums(t((t(X.row.sup)-marge.col)^2/marge.col))

X.col.sup <- children[c(1:14),c(6:8)]
X.col.sup <- X.col.sup*row.w
colnames(X.col.sup) <- colnames(Xtot)[col.sup]
somme.col <- colSums(X.col.sup)
X.col.sup <- t(t(X.col.sup)/somme.col)


ncp=5
total <- sum(X*row.w)
F <- as.matrix(X)*(row.w/total)
marge.col <- colSums(F)
marge.row <- rowSums(F)
ncp <- min(ncp, (nrow(X) - 1), (ncol(X) - 1))
Tc <- t(t(F/marge.row)/marge.col) - 1

X <- t(t(Tc)*sqrt(marge.col))*sqrt(marge.row)

s_v_d = svd(X)
s_v_d$d
s_v_d$u/sqrt(marge.row)
s_v_d$v/sqrt(marge.col)

U <- res.ca$svd$U
V <- res.ca$svd$V
eig <- res.ca$eig[,1][1:ncol(U)]
t(t(V)*sqrt(eig))

rm(list = ls())
library(FactoMineR)
library(factoextra)

data(mortality)
res<-MFA(mortality,group=c(9,9),type=c("f","f"),
         name.group=c("1979","2006"),graph = F)

fviz_contrib(res,choice = "partial.axes")

###################################### row informations
#######################################################
# Individuals informations
#######################################################
head(res$ind$coord)
head(res$ind$cos2)
head(res$ind$contrib)
head(res$ind$coord.partiel)
res$ind$within.inertia
res$ind$within.partial.inertia

#############################################################
freq <- res$freq
head(freq$coord)
head(freq$contrib)
head(freq$cos2)


######################## Partial axes
partial_axes <- res$partial.axes
partial_axes$coord
partial_axes$contrib
round(partial_axes$cor.between,4)

######################### group informations
group <- res$group
group$coord
group$dist2

summary(res)

fviz_mfa_ind(res)
fviz_mfa_var(res,choice = "freq")

fviz_mfa_axes(res)
plot.MFA(res,choix = "freq",invisible = "ind")

################################################################
# Separate analysis

sep1 = res$separate.analyses$`1979`
head(sep1$ind$coord)

get_mfa_var(res,element = "freq")



res.mca$var$v.test


library(FactoMineR)
# Compute PCA with ncp = 3
res.pca <- PCA(USArrests, ncp = 3, graph = FALSE)
# Compute hierarchical clustering on principal components
res.hcpc <- HCPC(res.pca, graph = FALSE)

res.hcpc$desc.var$quanti

---
title: '**AFD sous Python avec scientisttools**'
author: "Duvérier DJIFACK ZEBAZE"
#date: "`r Sys.Date()`"
documentclass: article
geometry: "left=2.5cm,right=2.5cm,top=2.5cm,bottom=2.5cm, twoside=true"
fontsize: 11pt
line-height: 1.5
urlcolor: blue
linkcolor: blue
link-citations : yes
output: pdf_document
mainfont: Bookman Old Style
header-includes:
- \usepackage{pbox}
- \usepackage{caption}
- \usepackage{subcaption}
- \usepackage{natbib}
- \usepackage[utf8]{inputenc} # Caractères spéciaux
- \usepackage[french]{babel}
- \usepackage{amsmath, amsfonts, amssymb}   #Symboles mathématiques
- \usepackage{amsfonts}
# - \usepackage{minitoc} # [undotted] pour supprimer les pointillés
# - \mtcsetdepth{minitoc}{1} # 1 section, 2 sous-section 3 sous-sous-section
# - \mtcsettitle{minitoc}{Sommaire} # Changer le titre
- \usepackage{diagbox}
- \usepackage{lettrine}
- \usepackage[labelfont=bf]{caption}
- \captionsetup{font=scriptsize}
- \usepackage{booktabs}
- \usepackage{longtable}
- \usepackage{array}
- \usepackage{multirow}
- \usepackage{wrapfig}
- \usepackage{float}
- \usepackage{colortbl}
- \usepackage{pdflscape}
- \usepackage{tabu}
- \usepackage{threeparttable}
- \usepackage{threeparttablex}
- \usepackage[normalem]{ulem}
- \usepackage{makecell}
- \usepackage{xcolor}
- \usepackage{minitoc}
- \usepackage[Bjornstrup]{fncychap}
#- \usepackage[Conny]{fncychap} 
#- \usepackage[pdftex]{pict2e}
- \usepackage[dvipsnames]{xcolor}
- \usepackage{fourier-orns}
- \usepackage{fancyhdr}
- \usepackage{geometry}
- \geometry{a4paper,total={160mm,240mm},left=25mm,right=25mm,top=25mm,bottom=25mm}
- \usepackage[printsolution=true]{exercises}
- \usepackage{tikz}
---

```{r setup, include=FALSE}
library(reticulate)
library(knitr)
library(kableExtra)
knitr::opts_chunk$set(echo = TRUE,message=FALSE, warning=FALSE,fig.pos = "H",
                      out.extra = "",fig.align = "center",collapse =  FALSE,
                      highlight = TRUE)
```

Ce tutoriel a pour objectif de présenter rapidement les principales fonctionnalités offertes par le package \og scientisttools \fg{} pour réaliser une Analyse Factorielle Discriminante ou Analyse Discriminante Descriptive. 

<!-- https://marie-chavent.perso.math.cnrs.fr/teaching/ -->
<!-- https://thinkr.fr/creer-package-r-quelques-minutes/ -->

# Présentation des données

Nous allons illustrer ce tutoriel à travers l'exemple des Vins de Bordeaux (Michel Tenenhaus, 2007). On cherche à relier la qualité des vins de Bordeaux à des caractéristiques météorologiques. La variable à expliquer $y$ est la qualité du vin et prend $3$ modalités : 1 = bon, 2 = moyen et 3 = médiocre. Les variables explicatives de la qualité du vin sont les suivantes : $X_{1}$ (Somme des températures moyennes journalières (°C)), $X_{2}$ (Durée d'insolation (h)), $X_{3}$ (Nombre de jours de grande chaleur) et $X_4$ (Hauteur des pluies (mm)).


```{python}
# Chargement des données
import pandas as pd
data = pd.read_excel("./donnee/wine_quality.xls",index_col=1)
```

```{r vins-afd,engine='R',echo=FALSE}
knitr::kable(py$data, 
             caption = "Qualité des vins de Bordeaux",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size = 8,position="center",
                             latex_options = c("striped", "hold_position","repeat_header"))
```

Pour la suite, nous allons supprimer la colonne \og Obs \fg{} de notre jeu de données.

```{python}
# Suppression Obs.
donnee = data.drop(['Obs.'],axis=1)
```

\subsubsection{Objectifs}

L'analyse factorielle discriminante est une méthode descriptive. Elle vise à produire un système de représentation de dimension réduite qui permet de discerner les classes lorsqu'on y projette les individus. Il s'agit d'une méthode d'analyse factorielle. On peut la voir comme une variante de l'analyse en composantes principales où les centres de classes sont les individus, pondérés par leurs effectifs, et avec une métrique particulière (SAPORTA, 2006). Les variables latentes (ou discriminantes) sont exprimées par des combinaisons linéaires des variables originelles. Elles sont deux à deux orthogonales. Elles cherchent à assurer un écartement maximal entre les centres de classes. In fine, l'objectif est de mettre en évidence les caractéristiques qui permettent de distinguer au mieux les groupes.


\subsubsection{Problématique}

L'analyse factorielle discriminante ou analyse discriminante descriptive permet de caractériser de manière multidimensionnelle l'appartenance des individus à des groupes prédéfinis, ceci à l'aide de plusieurs variables explicatives prises de façon simultanée. En effet, il s'agit de construire un nouveau système de représentation qui permet de mettre en évidence ces groupes. Les objectifs de l'analyse factorielle discriminante sont double :

\begin{enumerate}
    \item \textbf{Descriptif} : Mettre en évidence les caractéristiques qui permettent de distinguer au mieux les groupes;
    
    \item \textbf{Prédictif} : Classer automatiquement un nouvel individu (l’affecter à un groupe) à partir de ses caractéristiques
\end{enumerate}


\subsubsection{Rapport de corrélation}

Nous mesurons le pouvons discriminant de chaque variables $X_{j}$ en utilisant l'analyse de la variance à un facteur. Pour cela, nous utilisons le rapport de corrélation définit par :

\begin{equation}
    \eta^{2}(X_{j}, y) = \dfrac{\text{Somme des carrés inter - classes}}{\text{Somme des carrés totale}}
\end{equation}

Cet indicateur, compris entre $0$ et $1$, est basé sur la dispersion des moyennes conditionnelles. Il s'agit d'un indicateur de séparabilité des groupes :


\begin{itemize}
\item $\eta^{2}(X_{j},y)=0$, la discrimination est impossible, les moyennes conditionnelles sont confondues. La somme des carrés inter - classes est nulle.

\item $\eta^{2}(X_{j},y)=1$, la discriminantion est parfaite, les points associés aux groupes sont agglutinés autour de leur moyenne respectives : la somme des carrés intra - classes est nulle, ce qui est équivalent à la somme des carrés inter - classes est egale à la somme des carrés totale.
\end{itemize}

```{python}
# Pouvoir discriminant
from scientisttools.utils import eta2

R2 = dict()
for name in donnee.columns[:-1]:
    R2[name] = eta2(donnee["Qualite"],donnee[name])
R2 = pd.DataFrame(R2).T
```

```{r,engine='R',echo=FALSE}
knitr::kable(round(py$R2,3), 
             caption = "Rapport de corrélation",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size = 8,position="center",
                             latex_options = c("striped", "hold_position","repeat_header"))
```

Toutes les p-values sont inférieures au seuil de $5\%$, par conséquent, il existe une différence significative dans la qualité du vin.

# AFD


## Chargement de scientisttools

Sage précaution avec les packages pour Python, nous affichons le numéro de la version de \og scientisttools \fg{} utilisée dans ce tutoriel. 

```{python}
# version
import scientisttools
print(scientisttools.__version__)
```

Nous fonctionnons avec la version \og 0.0.9 \fg{}.

```{python}
from scientisttools.discriminant_analysis import CANDISC
```

On crée une instance de la classe CANDISC, en lui passant ici des étiquettes pour les lignes et les variables. 

Le constructeur de la classe CANDISC possède un paramètre \texttt{n\_components} qui indique le nombre d'axes discriminants à garder. Par défaut, la valeur du paramètre \texttt{n\_components} est fixée à \texttt{None}.

Réalisez l'AFD sur toutes observations en tapant la ligne de code suivante :

```{python}
# Instanciation
my_cda = CANDISC(n_components=2,
                 target=["Qualite"],
                 row_labels=donnee.index,
                 features_labels=["Temperature","Soleil","Chaleur","Pluie"],
                 parallelize=False)
```
<
\begin{itemize}
\item \texttt{n\_components} : le nombre d'axes discriminants à garder dans les résultats
\item \texttt{target} : le label de la variable cible.
\item \texttt{row\_labels} : les noms des lignes
\item \texttt{features\_labels} : les noms des variables explicatives
\item \texttt{parallelize} : paralleliser l'algorithme.
\end{itemize}

On estime le modèle en appliquant la méthode \texttt{.fit} de la classe CANDISC sur le jeu de données à traiter.

```{python}
# Apprentissage
my_cda.fit(donnee)
```


## Les valeurs propres

L'exécution de la méthode \texttt{my\_cda.fit(donnee)} provoque le calcul de plusieurs attributs parmi lesquels \texttt{my\_cda.eig\_}.

```{python}
print(my_cda.eig_)
```


L'attribut \texttt{my\_cda.eig\_} contient :

\begin{itemize}
\item en 1ère ligne : les valeurs propres en valeur absolue
\item en 2ème ligne : les différences des valeurs propres
\item en 3ème ligne : les valeurs propres en pourcentage de la variance totale (proportions)
\item en 4ème ligne : les valeurs propres en pourcentage cumulé de la variance totale.
\end{itemize}

La fonction \texttt{get\_eig} retourne les valeurs propres sous forme de tableau de données.

```{python}
# Valeurs propres
from scientisttools.extractfactor import get_eig
print(get_eig(my_cda))
```

Le premier axe discriminant contient $96\%$ de l'information totale disponible.

On peut obtenir un résumé des principaux résultats en utilisant la fonction \texttt{summaryCANDISC}.

```{python}
from scientisttools.extractfactor import summaryCANDISC
summaryCANDISC(my_cda)
```


Le champ \texttt{.coef\_} nous intéresse particulièrement. Il correspond aux coeffcients des fonctions discriminantes :

```{python}
# Affichage brut des ceofficients
print(my_cda.coef_)
```

La matrice est de dimension (4,2) puisque nous avons un problème à $(K=3)$ classes (d'où $K-1$ axes discriminants) et $4$ descripteurs.

```{python}
#dimensions
print(my_cda.coef_.shape)
```

Il ne faut pas oublier les constantes (\emph{intercept}) des fonctions discriminantes.

```{python}
# et les constantes pour chaque classe
print(my_cda.intercept_)
```

Nous pouvons dès lors adopter une présentation plus sympathique des fonctions discriminantes. Pour ce faire, nous utilisons la fonction \texttt{get\_candisc\_coef} en fixant le paramètre \og \texttt{choice = "absolute"} \fg{}.

```{python}
# Affichage des coefficients
from scientisttools.extractfactor import get_candisc_coef
coef = get_candisc_coef(my_cda,choice="absolute")
coef
```

# Représentations factorielles

## Coordonnées des individus

```{python}
# Coordonnées des individus
from scientisttools.extractfactor import get_candisc_row
row_coord = get_candisc_row(my_cda)["coord"]
print(row_coord.head(6))
```

```{python,out.width="90%"}
# Carte des individus
from scientisttools.pyplot import plotCANDISC
import matplotlib.pyplot as plt 

fig, axe = plt.subplots(figsize=(16,8))
plotCANDISC(my_cda,color=["blue",'#5DC83F','red'],marker=['o',"*",'>'],ax=axe)
plt.show()
```


## Coordonnées des centres de classes

L'introduction des barycentre spermet de mieux situer la qualité relative des facteurs dans la discrimination des classes.

```{python}
# Coordonnées des centres de classes
zk = my_cda.gcenter_
print(zk)
```


# Evaluation globale du modèle

## Evaluation statistique des facteurs

### Distance entre centres de classes

Dans le plan factoriel, les distances sont camptabilisées à l'aide d'une simple distance euclidienne.

```{python}
# Distances entre centres de classes
print(my_cda.gdisto_)
```


### Pouvoir discriminant des facteurs

Le pouvoir discriminant des facteurs est traduit par les valeurs propres qui leurs sont associées.

```{python}
print(get_eig(my_cda))
```

### Test MANOVA

Scientisttools forunit un test de sgnificativité globale du modèle.

```{python}
# Significativité globale du modèle
print(my_cda.manova_) 
```

Nous nous intéressons en particulier à la ligne relative à \og Wilks' Lambda \fg{}.

### Performance globale

Nosu affichons les valeurs des statistiques suivantes : Lambda de Wilks, Transformation de Bartlett et de RAO.


```{python}
# Performance globale
print(my_cda.global_performance_)
```

L'écartement entre les barycentres conditionnels est significatif à $5\%$. L'analyse discriminante est viable dans ce contexte.

### Test sur un ensemble de facteurs

Combien de facteurs faut - il retenir?.

```{python}
# Test sur un ensemble de facteur
print(my_cda.likelihood_test_)
```

## Matrices de covariance

Elles sont directement fournies par l'objet  \og scientisttools \fg{}

### Matrice de covariance intra - classe

```{python}
# Covariance intra - classe
print(my_cda.wcov_)
```

### Matrice de covariance totale

```{python}
# Covariance totale
print(my_cda.tcov_)
```

### Matrice de covariance inter - classe

```{python}
# Matrice de covaiance inter - classe
print(my_cda.bcov_)
```


## Interprétation des facteurs

Elle permet la compréhension de la nature des facteurs.

### Corrélation totale

```{python}
# Correlation totale
print(my_cda.tcorr_)
```

### Correlation intra - classe

```{python}
# Correlation intra - classe
print(my_cda.wcorr_)
```


### Correlation inter - classe


```{python}
# Corrélation inter - classe
print(my_cda.bcorr_)
```

## Prediction des classes

Considérons l'année 19858. Les données (hypothétiques) de cette année sont : 


```{python}
## Inidvidu supplémentaire
XTest = pd.DataFrame({"Temperature" : 3000,
                       "Soleil" : 1100, 
                       "Chaleur" : 20, 
                       "Pluie" : 300},index=[1958])
XTest
```

### Coordonnées factorielles 

```{python}
# Coordonées factorielles
row_sup_coord = my_cda.transform(XTest)
print(row_sup_coord)
```


```{python}
fig, axe = plt.subplots(figsize=(16,8))
plotCANDISC(my_cda,color=["blue",'#5DC83F','red'],marker=['o',"*",'>'],ax=axe)
axe.plot(row_sup_coord["LD1"],row_sup_coord["LD2"])
plt.show()
```

La fonction \texttt{predict()} permet de produire les prédictions à partir de la matrice des explicatives en test.

```{python}
# Prédiction simple
pred = my_cda.predict(XTest)
print(pred)
```

# Fonctions de classement explicites

La classe CANDISC de scientisttools retourne les fonctions de décision issues de l'analyse factorielle discriminante. Pour celà, il faut spécifier l'argument \og \texttt{choice == "score"}.

```{python}
# Fonctions de décision - AFD
score_coef = get_candisc_coef(my_cda,choice = "score")
print(score_coef)
```

## Prédiction des classes sur l'échantillon d'apprentissage

```{python}
import numpy as np
# Prédiction sur XTrain
X = donnee[donnee.columns[:-1]]
y_pred = my_cda.predict(X)

# Distribution des classes prédictes
print(np.unique(y_pred,return_counts=True))
```

$11$ observations ont été prédite \og Bon \fg{}, $11$ \og Medicocre\fg{} et $12$ \og Moyen \fg{}.

## Matrice de confusion et taux de bon classement

La matrice de confusion est issue de la confrontation entre ces prédictions et les classes observées. Nous faisons appel au module \og \href{https://scikit-learn.org/stable/modules/model_evaluation.html}{metrics} \fg{} de la librairie \og \href{https://scikit-learn.org/stable/index.html}{scikit-learn} \fg{}.

```{python}
# Matrice de confusion
from sklearn.metrics import confusion_matrix, ConfusionMatrixDisplay
cm = confusion_matrix(donnee.Qualite,y_pred,labels=my_cda.classes_)
disp = ConfusionMatrixDisplay(confusion_matrix=cm,
                              display_labels=my_cda.classes_)
disp.plot();
plt.show()
```


La fonction \texttt{score()} nous donne le taux de reconnaissance (ou taux de succès).

```{python}
# Taux de succès
print(my_cda.score(X,donnee.Qualite))
```

Notre taux de succès est de $79\%$.

La fonction \texttt{classification\_report()} génère un rapport sur les performances globales, mais aussi sur les reconnaissances par classe (rappel, précision et F-Measure[F1-Score])

```{python}
# rapport
from sklearn.metrics import classification_report
print(classification_report(donnee.Qualite,y_pred))
```

Nous retrouvons, entre autres le taux de succès de $79\%$.

## Probabilité d'appartenance

\og scientisttools \fg{} peut aussi calculer les probabilités d'affectation aux classes avec \texttt{predict\_proba()}. Elle permettent une analyse plus fine de la qualité du modèle, via la construction de la courbe ROC par exemple, dont le principe reste valable pour les problèmes multi - classes.

```{python}
# Probabilité d'appartenance
print(my_cda.predict_proba(X).head(6))
```


## Sélection de variables

Limiter le modèle aux variables explicatives pertinentes est primordial pour l'interprétation et le deploiement des modèles.

Actuellement sous \og scientisttools \fg{}, seule la sélection backward est disponible.

```{python}
# Selection backward
from scientisttools.discriminant_analysis import STEPDISC
stepdisc = STEPDISC(method="backward",alpha=0.01,model_train=True,verbose=True)
stepdisc.fit(my_cda)
```

```{python}
# Modèle optimal
stepdisc.train_model_
```

```{python}
# Représentation graphique
fig, axe =plt.subplots(figsize=(16,8))
plotCANDISC(stepdisc.train_model_,
            color=["blue",'#5DC83F','red'],
            marker=['o',"*",'>'],ax=axe)
plt.show()
```


```{python}
# Summary
summaryCANDISC(stepdisc.train_model_,to_markdown=False)
```


Bien qu'il soit possible de déduire un mécanisme de classement en analyse factorielle discriminante, sa finalité est bien différente de l'analyse discriminante linéaire, prédictive. Mais les deux approches se rejoignent.

Pour plus d'informations sur l'AFD sous scientisttools, consulter le notebook 

\href{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/candisc_wine.ipynb}{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/candisc\_wine.ipynb}.

---
title: '**AFDM sous Python avec scientisttools**'
author: "Duvérier DJIFACK ZEBAZE"
#date: "`r Sys.Date()`"
documentclass: article
geometry: "left=2.5cm,right=2.5cm,top=2.5cm,bottom=2.5cm, twoside=true"
fontsize: 11pt
line-height: 1.5
urlcolor: blue
linkcolor: blue
link-citations : yes
output: pdf_document
mainfont: Bookman Old Style
header-includes:
- \usepackage{pbox}
- \usepackage{caption}
- \usepackage{subcaption}
- \usepackage{natbib}
- \usepackage[utf8]{inputenc} # Caractères spéciaux
- \usepackage[french]{babel}
- \usepackage{amsmath, amsfonts, amssymb}   #Symboles mathématiques
- \usepackage{amsfonts}
# - \usepackage{minitoc} # [undotted] pour supprimer les pointillés
# - \mtcsetdepth{minitoc}{1} # 1 section, 2 sous-section 3 sous-sous-section
# - \mtcsettitle{minitoc}{Sommaire} # Changer le titre
- \usepackage{diagbox}
- \usepackage{lettrine}
- \usepackage[labelfont=bf]{caption}
- \captionsetup{font=scriptsize}
- \usepackage{booktabs}
- \usepackage{longtable}
- \usepackage{array}
- \usepackage{multirow}
- \usepackage{wrapfig}
- \usepackage{float}
- \usepackage{colortbl}
- \usepackage{pdflscape}
- \usepackage{tabu}
- \usepackage{threeparttable}
- \usepackage{threeparttablex}
- \usepackage[normalem]{ulem}
- \usepackage{makecell}
- \usepackage{xcolor}
- \usepackage{minitoc}
- \usepackage[Bjornstrup]{fncychap}
#- \usepackage[Conny]{fncychap} 
#- \usepackage[pdftex]{pict2e}
- \usepackage[dvipsnames]{xcolor}
- \usepackage{fourier-orns}
- \usepackage{fancyhdr}
- \usepackage{geometry}
- \geometry{a4paper,total={160mm,240mm},left=25mm,right=25mm,top=25mm,bottom=25mm}
- \usepackage[printsolution=true]{exercises}
- \usepackage{tikz}
---

```{r setup, include=FALSE}
library(reticulate)
library(knitr)
library(kableExtra)
knitr::opts_chunk$set(echo = TRUE,message=FALSE, warning=FALSE,fig.pos = "H",
                      out.extra = "",fig.align = "center",collapse =  FALSE,
                      highlight = TRUE)
```

Ce tutoriel a pour objectif de présenter rapidement les principales fonctionnalités offertes par le package \og scientisttools \fg{} pour réaliser une Analyse Factorielle des Données Mixtes. 

# Présentation des données

L’analyse factorielle des données mixtes traite les tableaux individus-variables, lesquelles sont composées d’un mix de quantitatives et qualitatives. Nous utilisons la base des données « Autos 2005 » accessible sur la page de cours de Pierre-Louis Gonzalez (\href{https://maths.cnam.fr/spip.php?article50}{https://maths.cnam.fr/spip.php?article50}) au CNAM. Notre base comporte $(I=38)$ modèles de véhicules décrits par $(K_{1}=9)$ variables quantitatives (puissance, cylindrée, vitesse, longueur, largeur, hauteur, poids, CO2 et prix) et $(K_{2}=3)$ variables qualitatives (origie avec $3$ modalités : France, Europe, Autres; carburant avec $2$ modalités : diesel, essence; type4X4 avec $2$ modalités : oui, non).

## Importation des données


```{python}
# Chargement des données
import pandas as pd
# Données actives
A = pd.read_excel("./donnee/autos2005.xlsx",sheet_name=0,index_col=0)
# Individus actifs
B = pd.read_excel("./donnee/autos2005.xlsx",sheet_name=1,index_col=0)
# Variables illustratives quantitatives
C = pd.read_excel("./donnee/autos2005.xlsx",sheet_name=2,index_col=0)
# Variables illustratives qualitatives
D = pd.read_excel("./donnee/autos2005.xlsx",sheet_name=3,index_col=0)
C.index = D.index = A.index
# Concaténation
Data = pd.concat([pd.concat([A,B],axis=0),C,D],axis=1)
# Affichage des caractéristiques
Data.info()
```

```{r autos2005-data,engine='R',echo=FALSE}
knitr::kable(py$Data, 
             caption = "Données Autos 2005",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::column_spec(c(13,16,17),border_right = TRUE) %>%
  kableExtra::row_spec(38,hline_after = TRUE) %>%
  kableExtra::kable_styling(position="center",
                            latex_options = c("striped", "hold_position","repeat_header","scale_down"))
```

Les variables coffre, reservoir et consommation seront utilisées comme illustratives quantitatives et \og surtaxe \fg{} comme illustrative qualitative. Certaines voitures ont été mises en illustratives.

Les questions usuelles que l'on se pose sont les suivantes : 

\begin{enumerate}
\item Quelles sont les véhicules qui se ressemblent, c'est - à - dire qui présentent des caractéristiques similaires? Il sera question d'étudier les proximités entre les individus.
\item Sur quelles caractéristiques sont basées les ressemblances et dissemblances, avec la difficulté ici de les comptabiliser de manière différenciée selon que les variables incriminées sont quantitatives ou qualitatives.
\item Quelles sont les relations entre les variables? Entre quantitatives, l'idée de la corrélation s'impose; entre qualitatives, le $\chi^{2}$ de contingence. Mais comment faire entre quantitatives et qualitatives? (rapport de corrélation, etc.)
\end{enumerate}

# AFDM

## Objectifs 

L'objectif est de trouver un système de représentation  (répère factoriel) qui préserve au mieux les distances entre les individus, qui permet de discerner le mieux possible les individus entre eux, qui maximise les (le carré des) écarts à l'origine.

## Chargement de scientisttools

```{python}
from scientisttools.decomposition import FAMD
```

## Individus et variables actifs

On crée une instance de la classe FAMD, en lui passant ici des étiquettes pour les lignes et les variables. Ces paramètres sont facultatifs ; en leur absence, le programme détermine automatiquement des étiquettes.

```{python}
# Instanciation
my_famd = FAMD(normalize=True,
               n_components=None,
               row_labels= A.index,
               quanti_labels= list(A.columns[:9]),
               quali_labels=list(A.columns[9:]),
               row_sup_labels=None,
               quanti_sup_labels=None,
               quali_sup_labels=None,
               parallelize=False)
```

On estime le modèle en appliquant la méthode \texttt{fit} de la classe FAMD sur le jeu de données.

```{python}
# Estimation du modèle
my_famd.fit(A)
```


### Les valeurs propres

L'exécution de la méthode \texttt{my\_famd.fit(A)} provoque le calcul des attributs parmi lesquels \texttt{my\_famd.eig\_} pour les valeurs propres.

```{python}
# Valeurs propres
print(my_famd.eig_)
```

L'attribut \texttt{my\_famd.eig\_} contient :

\begin{itemize}
\item en 1ère ligne : les valeurs propres en valeur absolue
\item en 2ème ligne : les différences des valeurs propres
\item en 3ème ligne : les valeurs propres en pourcentage de la variance totale (proportions)
\item en 4ème ligne : les valeurs propres en pourcentage cumulé de la variance totale.
\end{itemize}

La fonction \texttt{get\_eig} retourne les valeurs propres sous forme de tableau de données.

```{python}
# Valeurs propres
from scientisttools.extractfactor import get_eig
print(get_eig(my_famd))
```

Les valeurs propres peuvent être représentées graphiquement : 

```{python}
from scientisttools.pyplot import plot_eigenvalues
import matplotlib.pyplot as plt
fig, axe = plt.subplots(figsize=(16,6))
plot_eigenvalues(my_famd,choice="eigenvalue",ax=axe)
plt.show()
```

```{python}
fig, axe = plt.subplots(figsize=(16,6))
plot_eigenvalues(my_famd,choice="proportion",ax=axe)
plt.show()
```

Même si le mécanisme sous - jacent de l'AFDM repose sur une ACP, nous ne pouvons pas vraiment utiliser les stratégies usuelles.

\begin{itemize}
\item Avec la règle de Kaiser, nous sélectionnerons les facteurs tels que $\lambda_{\alpha} \geq 1$, c'est - à - dire $H=3$. On se rend compte en pratique que ce critère est trop permissif, nous retenons un nombre excessif de facteurs parce qu'une partie de l'information est rédondante comme en ACM. 
\item Avec la règle de Karlis - Saporta - Spinaki, la valeur seuil est surestimé parce que le nombre de colonnes $K$ des données présentées à l'ACP est \og surévalué \fg{}, des redondances ont été artificiellement introduites.
\end{itemize}

De fait, les critères de l'ACP ne s'appliquent pas ici parce que les données ne sont pas composées de variables nativement quantitatives, certaines colonnes sont liées entre elles avec le codage disjonctif complet des variables qualitatives.

Finalement, on en revient au diagramme des valeurs propres et la recherche de \og coudes \fg{}, annonciateurs de changement significatif de structure dans les données. 


```{python}
fig, axe = plt.subplots(figsize=(16,6))
plot_eigenvalues(my_famd,choice="eigenvalue",ax=axe)
plt.show()
```


Nous avons un \og coude \fg{} au niveau de $h=2$. Nous choisissons de retenir $H=2$.

On peut obtenir un résumé des principaux résultats en utilisant la fonction \texttt{summaryFAMD}.

```{python}
from scientisttools.extractfactor import summaryFAMD
summaryFAMD(my_famd)
```

## Représentation graphique

```{python,out.width="70%"}
# Carte des individus
from scientisttools.ggplot import fviz_famd_ind
print(fviz_famd_ind(my_famd,color="blue",repel=True))
```


```{python, out.width="70%"}
# Carte des modalités - variables qualitatives
from scientisttools.ggplot import fviz_famd_mod
print(fviz_famd_mod(my_famd,color="red",repel=True))
```

```{python, out.width="65%"}
# Cercle des corrélations - variables quantitatives
from scientisttools.ggplot import fviz_famd_col
print(fviz_famd_col(my_famd,color="blue"))
```


```{python, out.width="70%"}
# Carte des variables - rapport de corrélation et cosinus carré
from scientisttools.pyplot import plotFAMD
fig, axe = plt.subplots(figsize=(10,10))
plotFAMD(my_famd,choice="var",repel=True)
plt.show()
```


# AFDM avec les éléments supplémentaires

Les individus illustratifs et les variables illustratives n'influencent pas la construction des composantes principales de l'analyse. Ils/Elles aident à l'interprétation des dimensions de variabilité.

On peut ajouter deux types de variables : continues et qualitatives.
Tapez la ligne de code suivante :

```{python}
# AFDM avec les éléments supplémentaires
my_famd2 = FAMD(normalize=True,
                n_components=None,
                row_labels= A.index,
                quanti_labels= list(A.columns[:9]),
                quali_labels=list(A.columns[9:]),
                row_sup_labels=B.index,
                quanti_sup_labels=list(C.columns),
                quali_sup_labels=list(D.columns),
                parallelize=False)
# Estimation
my_famd2.fit(Data)
```


```{python,out.width="90%"}
# Carte des individus
from scientisttools.pyplot import plotFAMD
fig, axe = plt.subplots(figsize=(10,10))
plotFAMD(my_famd2,choice="ind",ind_sup=True,xlim=(-8,5),ylim=(-5,4),
         repel=True,ax=axe)
plt.show()
```

```{python,out.width="65%"}
# Carte des modalités
print(fviz_famd_mod(my_famd2,color="blue",repel=True))
```


```{python,out.width="90%"}
# Cercle des corrélations des variables
fig, axe = plt.subplots(figsize=(10,10))
plotFAMD(my_famd2,choice="col",color="blue",ax=axe)
plt.show()
```


# Interprétation des axes

Des graphiques qui permettent d'interpréter rapidement les axes : on choisit un axe factoriel (le 1er axe dans notre exemple) et on observe quels sont les points lignes et colonnes qui présentent les plus fortes contributions et cos2 pour cet axe.

```{python, out.width="90%"}
# Classement des points lignes en fonction de leur contribution au 1er axe
from scientisttools.pyplot import plot_contrib, plot_cosines
fig, axe = plt.subplots(figsize=(16,8))
plot_contrib(my_famd2,choice="ind",axis=0,top_contrib=10,ax=axe)
plt.show()
```


```{python,out.width="90%"}
# Classement des modalités en fonction de leur contribution au 1er axe
fig, axe = plt.subplots(figsize=(16,8))
plot_contrib(my_famd2,choice="mod",axis=0,ax=axe)
plt.show()
```

```{python,out.width="85%"}
# Classement des individus en fonction de leur cos2 sur le 1er axe
fig, axe = plt.subplots(figsize=(16,8))
plot_cosines(my_famd2,choice="ind",axis=0,top_cos2=10,ax=axe)
plt.show()
```


```{python,out.width="85%"}
# Classement des modalités en fonction de leur cos2 sur le 1er axe
fig, axe = plt.subplots(figsize=(16,8))
plot_cosines(my_famd2,choice="mod",axis=0,ax=axe)
plt.show()
```

# Approche Machine Learning

Ici, l'objectif est d'utiliser l'Analyse Factorielle des Données Mixtes en tant que méthode de prétraitement.

La classe FAMD implémente les méthodes \texttt{fit}, \texttt{transform} et \texttt{fit\_transform} bien connues des utilisateurs de scikit-learn.

```{python}
my_famd.transform(A)[:5,:2]
```


```{python}
my_famd.fit_transform(A)[:5,:2]
```


## Intégration dans une Pipeline de scikit-learn

La class \texttt{FAMD} peut être intégrée dans une Pipeline de scikit-learn. Dans le cadre de notre exemple, nous cherchons à prédire la variable (variable "Prix") à partir des $11$ autres variables du jeu de données (données actives). 

"prix" est une variable quantitative. Pour la prédire, nous allons utiliser un modèle de régression linéaire qui prendra en input des axes issus d'une Analyse Factorielle des Données Mixtes pratiquée sur les données brutes.

Dans un premier temps, et de façon tout à fait arbitraire, nous fixons le nombre de composantes extraites à 4.

```{python}
from sklearn.pipeline import Pipeline
from sklearn.linear_model import LinearRegression
from sklearn.model_selection import GridSearchCV

# X = features
X = A.drop(columns=["prix"])
# y = target
y = A.prix

# Construction de la Pipeline
# On enchaine une Analyse Factorielle des Données Mixtes (4 axes retenus) 
# puis une régression linéaire
pipe = Pipeline([("famd", FAMD(n_components=4)), 
                 ("ols", LinearRegression())])
# Estimation du modèle
pipe.fit(X, y)
```

On prédit

```{python}
# Prédiction sur l'échantillon de test
print(pipe.predict(B))
```


Le paramètre \texttt{n\_components} peut faire l'objet d'une optimisation via GridSearchCV de scikit-learn.

Nous reconstruisons donc une Pipeline, sans spécifier de valeur a priori pour n_components.

```{python}
# Reconstruction d'une Pipeline, sans spécifier de valeur 
# a priori pour n_components
pipe2 = Pipeline([("famd", FAMD()), 
                  ("ols", LinearRegression())])
                  
# Paramétrage de la grille de paramètres
# Attention à l'étendue des valeurs possibles pour famd__n_components !!!
param = [{"famd__n_components": [x + 1 for x in range(12)]}]

# Construction de l'objet GridSearchCV
grid_search = GridSearchCV(pipe2, 
                           param_grid=param, 
                           scoring="neg_mean_squared_error",
                           cv=5,
                           verbose=0)
# Estimation du modèle
grid_search.fit(X, y)
```


```{python}
# Affichage du score optimal
grid_search.best_score_
```


```{python}
# Affichage du RMSE optimal
import numpy as np
print(np.sqrt(-grid_search.best_score_))
```


```{python}
# Affichage du paramètre optimal
grid_search.best_params_
```

```{python}
# Prédiction sur l'échantillon de test
grid_search.predict(B)
```

Pour plus d'informations sur l'AFDM sous scientisttools, consulter le notebook 

\href{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/famd_example.ipynb}{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/famd\_example.ipynb}.

---
title: '**ADL sous Python avec scientisttools**'
author: "Duvérier DJIFACK ZEBAZE"
#date: "`r Sys.Date()`"
documentclass: article
geometry: "left=2.5cm,right=2.5cm,top=2.5cm,bottom=2.5cm, twoside=true"
fontsize: 11pt
line-height: 1.5
urlcolor: blue
linkcolor: blue
link-citations : yes
output: pdf_document
mainfont: Bookman Old Style
header-includes:
- \usepackage{pbox}
- \usepackage{caption}
- \usepackage{subcaption}
- \usepackage{natbib}
- \usepackage[utf8]{inputenc} # Caractères spéciaux
- \usepackage[french]{babel}
- \usepackage{amsmath, amsfonts, amssymb}   #Symboles mathématiques
- \usepackage{amsfonts}
# - \usepackage{minitoc} # [undotted] pour supprimer les pointillés
# - \mtcsetdepth{minitoc}{1} # 1 section, 2 sous-section 3 sous-sous-section
# - \mtcsettitle{minitoc}{Sommaire} # Changer le titre
- \usepackage{diagbox}
- \usepackage{lettrine}
- \usepackage[labelfont=bf]{caption}
- \captionsetup{font=scriptsize}
- \usepackage{booktabs}
- \usepackage{longtable}
- \usepackage{array}
- \usepackage{multirow}
- \usepackage{wrapfig}
- \usepackage{float}
- \usepackage{colortbl}
- \usepackage{pdflscape}
- \usepackage{tabu}
- \usepackage{threeparttable}
- \usepackage{threeparttablex}
- \usepackage[normalem]{ulem}
- \usepackage{makecell}
- \usepackage{xcolor}
- \usepackage{minitoc}
- \usepackage[Bjornstrup]{fncychap}
#- \usepackage[Conny]{fncychap} 
#- \usepackage[pdftex]{pict2e}
- \usepackage[dvipsnames]{xcolor}
- \usepackage{fourier-orns}
- \usepackage{fancyhdr}
- \usepackage{geometry}
- \geometry{a4paper,total={160mm,240mm},left=25mm,right=25mm,top=25mm,bottom=25mm}
- \usepackage[printsolution=true]{exercises}
- \usepackage{tikz}
---

```{r setup, include=FALSE}
library(reticulate)
library(knitr)
library(kableExtra)
knitr::opts_chunk$set(echo = TRUE,message=FALSE, warning=FALSE,fig.pos = "H",
                      out.extra = "",fig.align = "center",collapse =  FALSE,
                      highlight = TRUE)
```

Ce tutoriel a pour objectif de présenter rapidement les principales fonctionnalités offertes par le package \og scientisttools \fg{} pour réaliser une Analyse Discriminante Linéaire. 

# Présentation des données

L'analyse discriminante linéaire fait partie des technique d'analyse discriminante prédictive. C'est une méthode prédictive où le modèle s'exprime sous la forme d'un système d'équations linéaires des variables explicatives. Il s'agit d'expliquer et de prédire l'appartenance d'un individu à une classe (groupe) prédéfinie à partir de ses caractéristiques mesurées à l'aide de variables prédictives.

## Importation des données

Nous utilisons les données \og alcool \fg{}(\emph{cf.} \href{https://eric.univ-lyon2.fr/ricco/tanagra/fichiers/fr_Tanagra_LDA_Python.pdf}{fr\_Tanagra\_LDA\_Python.pdf}). Il s'agit de prédire le TYPE d'alcool (KIRSCH, MIRAB, POIRE) à partir de ses composants (butanol, méthanol, etc; $8$ variables).

```{python}
# Chargement des données
import pandas as pd
DTrain = pd.read_excel("./donnee/Eau_de_vie_LDA.xlsx",sheet_name="TRAIN")
print(DTrain.info())
```

## Distribution relative

Nous calculons la distribution relative des classes :

```{python}
# Distribution relative des classes
d = (DTrain.TYPE.value_counts(normalize=True).reset_index()
                .rename(columns={"index":"TYPE","TYPE":"p(k)"}))
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$d, 
             caption = "Distribution relative des classes",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Les classes semblent assez équilibrées.

# LDA

## Modélisation avec scientisttools

Sage précaution avec les packages pour Python, nous affichons le numéro de la version de \og scientisttools \fg{} utilisée dans ce tutoriel. 

```{python}
# version
import scientisttools
print(scientisttools.__version__)
```

Nous fonctionnons avec la version \og 0.0.9 \fg{}.

```{python}
# Importation
from scientisttools.discriminant_analysis import LDA
```

On crée une instance de la classe LDA, en lui passant ici des étiquettes pour les lignes et les variables. 

```{python}
# Instanciation
lda = LDA(features_labels=DTrain.columns[1:].values,
          target=["TYPE"],
          distribution = "homoscedastik",
          row_labels=DTrain.index,
          priors = None,
          parallelize=False)
```

On estime le modèle en appliquant la méthode \texttt{.fit} de la classe LDA sur le jeu de données.

```{python}
# Entraînement du modèle
lda.fit(DTrain)
```

L'exécution de la méthode \texttt{lda.fit(D)} provoque le calcul de plusieurs attributs parmi lesquels \texttt{lda.coef\_}. Ce champ nous intéresse particulièrement car il correspond aux coefficients des fonctions de classement.

```{python,eval=FALSE}
# Coefficients des fonctions de score
print(lda.coef_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$lda$coef_, 
             caption = "Coefficients des fonctions de score",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Le tableau est de dimension $(8,3)$ puisque nous avons un problème à $(K=3)$ classes (le nombre de modalités de la variable cible origine) et $8$ descripteurs.

Il ne faut pas oublier les constantes (intercept) des fonctions linéaires :

```{python,eval=FALSE}
# et les constantes pour chaque classe
print(lda.intercept_)
```


```{r,engine='R',echo=FALSE}
knitr::kable(py$lda$intercept_, 
             caption = "Constantes pour chaque classe",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

## Inspection de l'objet LDA

\begin{itemize}
\item \texttt{priors\_} correspond à la distribution relative des classes.
\end{itemize}

```{python,eval=FALSE}
# distribution des classes
print(lda.priors_)
```


```{r,engine='R',echo=FALSE}
knitr::kable(t(py$lda$priors_), 
             caption = "Distribution relative pour chaque classe",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

\begin{itemize}
\item \texttt{class\_level\_information\_} correspond à la distribution absolue et relative des classes 
\end{itemize}

```{python,eval=FALSE}
# distribution absolue et relative des classes
print(lda.class_level_information_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$lda$class_level_information_, 
             caption = "Distribution absolue et relative pour chaque classe",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

\begin{itemize}
\item \texttt{correlation\_ratio\_} correspond au rapport de corrélation $\eta^{2}(X,y)$ entre les variables explicatives et la variable expliquée.
\end{itemize}

```{python,eval=FALSE}
# Rapport de corrélation
print(lda.correlation_ratio_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$lda$correlation_ratio_, 
             caption = "Rapport de correlation",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

\begin{itemize}
\item \texttt{gmean\_} indique les moyennes des variables conditionnellement aux classes
\end{itemize}

```{python,eval=FALSE}
# moyennes conditionnelles des variables
print(lda.gmean_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$lda$gmean_,, 
             caption = "Moyennes conditionnelles",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

\begin{itemize}
\item \texttt{mean\_} indique les moyennes des variables explicatives
\end{itemize}

```{python,eval=FALSE}
# moyennes des variables
print(lda.mean_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(t(py$lda$mean_),, 
             caption = "Moyennes des variables",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

\begin{itemize}
\item \texttt{std\_} indique les écart types des variables explicatives
\end{itemize}

```{python,eval=FALSE}
# écarts types des variables
print(lda.std_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(t(py$lda$std_),, 
             caption = "Ecart - types des variables",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


\begin{itemize}
\item \texttt{squared\_mdist\_} indique la matrice des distances (au carré) de Mahalanobis
\end{itemize}

```{python,eval=FALSE}
# Matrice des distances (au carré) de Mahalanobis
print(lda.squared_mdist_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$lda$squared_mdist_,, 
             caption = "Ecart - types des variables",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


# Evaluation globale du modèle

## Statistiques multivariées

Le test de significativité globale du modèle est basé sur l'écartement entre les barycentres conditionnels pour l'analyse discriminante.

```{python}
# MANOVA Test
print(lda.manova_)
```

Nous nous intéressons en particulier à la ligne relative à \og Wilks' Lambda \fg{}.

## Matrice de covariance

### Matrice de covariance intra - classe

Elle est directement fournie par l'objet \og scientisttools \fg{}.

```{python,eval=FALSE}
# Matrice de covariance intra - classe
print(lda.wcov_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(round(py$lda$wcov_,2), 
             caption = "Matrice de covariance intra - classe",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

### Matrice de covariance totale

La matrice de covariance totale est proposée par l'objet \og scientisttools \fg{}.

```{python,eval=FALSE}
# Matrice de covariance totale
print(lda.tcov_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(round(py$lda$tcov_,2), 
             caption = "Matrice de covariance totale",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


### Matrice de covariance inter - classe

La matrice de covariance inter - classe est proposée par l'objet \og scientisttools \fg{}.

```{python,eval=FALSE}
# Matrice de covariance inter - classe
print(lda.bcov_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(round(py$lda$bcov_,2), 
             caption = "Matrice de covariance inter - classe",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

## Autres indicateurs : Lambda de Wilks, Transformation de RAO et de Bartlett.

Ces trois indicateurs sont retournés par l'objet \og scientisttools \fg{}.

```{r,eval=FALSE}
# MANOVA test
print(lda.global_performance_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$lda$global_performance_, 
             caption = "Performance globale",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


# Evaluation des contributions des variables

Mesurer l'impact des variables est crucial pour l'interprétation du mécanisement d'affectation. Pour l'analyse discriminante, il est possible de produire une mesure d'importance des variables basée sur leurs contributions à la discrimination. Concrètement, il s'agit simplement d'opposer les lambdas de Wilks avec ou sans la variable à évaluer.

## Affichage des contributions sous Python

Ces résultats sont fournis directement par l'objet \og scientisttools \fg{}

```{python,eval=FALSE}
# Evaluation statistique
print(lda.statistical_evaluation_)
```

```{r lambda-wilks,engine='R',echo=FALSE}
knitr::kable(round(py$lda$statistical_evaluation_,4), 
             caption = "Contribution des variables",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Dans le tableau \ref{tab:lambda-wilks}, nous distinguons le lambda de Wilks lorsque la variable est rétirée (Wilks L; `r py$lda$statistical_evaluation_[1,1]` si on retire la variable `r rownames(py$lda$statistical_evaluation_)[1]` par exemple), le ratio entre le lambda global (`r py$lda$global_performance_[1,2]`) et ce dernier (Partial L; pour `r rownames(py$lda$statistical_evaluation_)[1]` : `r py$lda$global_performance_[1,2]` / `r py$lda$statistical_evaluation_[1,1]` = `r py$lda$statistical_evaluation_[1,2]`), et la statistique de test de significativité de l'écart (F = `r py$lda$statistical_evaluation_[1,3]`) qui suit une distribution de Fisher à $(K-1=2)$ et $(N-K-p+1=42)$.

# Evaluation en Test

L'avaluation sur l'échantillon test est une approche priviligiée pour mesurer et comparer les performances des modèles de nature et de complexité différente. Dans cette section, nnous traitons la seconde feuille \og TEST \fg{} comportant $50$ observations de notre classeur Excel.

## Importation des données

Nous chargeons la feuille \og TEST \fg{}. 

```{python}
# chargement échantillon TEST
DTest = pd.read_excel("./donnee/Eau_de_vie_LDA.xlsx",sheet_name="TEST")
print(DTest.info())
```

Nous affichons pour vérification la distribution des classes.

```{python}
# Distribution relative des classes
dtest = (DTest.TYPE.value_counts(normalize=True).reset_index()
                   .rename(columns={"index":"TYPE","TYPE":"p(k)"}))
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$dtest, 
             caption = "Distribution relative des classes - TEST",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


Elle est similaire à celle de l'échantillon \og TRAIN \fg{}.

## Prédiction des classes sur l'échantillon d'apprentissage

Il y a deux étapes dans l'évaluation : 
\begin{enumerate}
\item Effectuer la prédiction à partir de la matrice des explicatives de l'échantillon test;
\item Confronter les prédictions de l'étape 1 avec les classes observées.
\end{enumerate}

### Probabilité d'appartenance

L'objet \og scientisttools \fg{} calcule les probabilités d'affectation aux classes avec \texttt{predict\_proba()}. Elle permettent une analyse plus fine de la qualité du modèle, via la construction de la courbe ROC par exemple, dont le principe reste valable pour les problèmes multi - classes.

```{python}
# Matrice X en Test
XTest = DTest[DTest.columns[1:]]
# Probabilité d'appartenance
print(lda.predict_proba(XTest).head(6))
```


### Classe d'appartenance

L'objet \og scientisttools \fg{} calcule les classes d'appartenance avec la fonction \texttt{predict()}. Elle permet de produire les prédictions à partir de la matrice des explicatives en test.

```{python}
# Prédiction sur XTest
y_pred = lda.predict(XTest)
```

On calcule la distribution d'appartenance

```{python}
# Distribution des classes prédictes
import numpy as np
# print(np.unique(y_pred,return_counts=True))
y_pred.value_counts(normalize=False)
```

$19$ observations ont été prédite \og MIRAB \fg{}, $16$ \og POIRE \fg{} et $15$ \og KIRSCH \fg{}.

## Matrice de confusion et taux de bon classement

La matrice de confusion est issue de la confrontation entre ces prédictions et les classes observées. Nous faisons appel au module \og \href{https://scikit-learn.org/stable/modules/model_evaluation.html}{metrics} \fg{} de la librairie \og \href{https://scikit-learn.org/stable/index.html}{scikit-learn} \fg{}.

```{python,fig.cap = "Matrice de confusion",out.width="50%"}
# Matrice de confusion
import matplotlib.pyplot as plt
from sklearn.metrics import confusion_matrix, ConfusionMatrixDisplay
cm = confusion_matrix(DTest.TYPE,y_pred,labels=lda.classes_)
disp = ConfusionMatrixDisplay(confusion_matrix=cm,
                              display_labels=lda.classes_)
disp.plot(cmap=plt.cm.Blues,values_format='g');
plt.show()
```


La fonction \texttt{score()} nous donne le taux de reconnaissance (ou taux de succès).

```{python}
# Taux de succès
print(lda.score(XTest,DTest.TYPE))
```

Notre taux de succès est de $82\%$.

La fonction \texttt{classification\_report()} génère un rapport sur les performances globales, mais aussi sur les reconnaissances par classe (rappel, précision et F-Measure[F1-Score])

```{python}
# rapport
from sklearn.metrics import classification_report
print(classification_report(DTest.TYPE,y_pred))
```

Nous retrouvons, entre autres le taux de succès de $82\%$.

Pour plus d'informations sur l'ADL sous scientisttools, consulter le notebook 

\href{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/lda_example.ipynb}{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/lda\_example.ipynb}.

---
title: '**Classification Hiérarchique sur Composantes Principales sous Python avec scientisttools**'
author: "Duvérier DJIFACK ZEBAZE"
#date: "`r Sys.Date()`"
documentclass: article
geometry: "left=2.5cm,right=2.5cm,top=2.5cm,bottom=2.5cm, twoside=true"
fontsize: 11pt
line-height: 1.5
urlcolor: blue
linkcolor: blue
link-citations : yes
output: pdf_document
mainfont: Bookman Old Style
header-includes:
- \usepackage{pbox}
- \usepackage{caption}
- \usepackage{subcaption}
- \usepackage{natbib}
- \usepackage[utf8]{inputenc} # Caractères spéciaux
- \usepackage[french]{babel}
- \usepackage{amsmath, amsfonts, amssymb}   #Symboles mathématiques
- \usepackage{amsfonts}
# - \usepackage{minitoc} # [undotted] pour supprimer les pointillés
# - \mtcsetdepth{minitoc}{1} # 1 section, 2 sous-section 3 sous-sous-section
# - \mtcsettitle{minitoc}{Sommaire} # Changer le titre
- \usepackage{diagbox}
- \usepackage{lettrine}
- \usepackage[labelfont=bf]{caption}
- \captionsetup{font=scriptsize}
- \usepackage{booktabs}
- \usepackage{longtable}
- \usepackage{array}
- \usepackage{multirow}
- \usepackage{wrapfig}
- \usepackage{float}
- \usepackage{colortbl}
- \usepackage{pdflscape}
- \usepackage{tabu}
- \usepackage{threeparttable}
- \usepackage{threeparttablex}
- \usepackage[normalem]{ulem}
- \usepackage{makecell}
- \usepackage{xcolor}
- \usepackage{minitoc}
- \usepackage[Bjornstrup]{fncychap}
#- \usepackage[Conny]{fncychap} 
#- \usepackage[pdftex]{pict2e}
- \usepackage[dvipsnames]{xcolor}
- \usepackage{fourier-orns}
- \usepackage{fancyhdr}
- \usepackage{geometry}
- \geometry{a4paper,total={160mm,240mm},left=25mm,right=25mm,top=25mm,bottom=25mm}
- \usepackage[printsolution=true]{exercises}
- \usepackage{tikz}
---

```{r setup, include=FALSE}
library(reticulate)
library(knitr)
library(kableExtra)
knitr::opts_chunk$set(echo = TRUE,message=FALSE, warning=FALSE,fig.pos = "H",
                      out.extra = "",fig.align = "center",collapse =  FALSE,
                      highlight = TRUE)
```

Ce tutoriel a pour objectif de présenter rapidement les principales fonctionnalités offertes par le package \og scientisttools \fg{} pour réaliser une classification hiérarchique combinée avec une analyse factorielle (HCPC, \emph{Hierarchical Clustering on Principal Components}).

# Présentation des données

On va réaliser une classification hiérarchique sur les composantes principales d'une analyse factorielle. Nous allons prendre un exemple sur les données météorologiques. Les données sur lesquelles nous allons travailler proviennent d’un jeu de données d’étudiants français qui avaient pris cela comme sujet d’examen (Tableau \ref{tab:temperature-data}). En lignes, les individus statistiques sont représentés par les $15$ villes de France sélectionnées et en colonnes les températures mensuelles moyennes. Ces températures mensuelles moyennes ont été calculées sur $30$ ans. Donc, par exemple, à Bordeaux en Janvier, il fait en moyenne $5.6$ degrés. Cette valeur de $5.6$ degrés est la moyenne sur tous les jours de Janvier pendant 30 ans. On a ainsi $12$ variables correspondants au $12$ mois de l'année. On retrouve également en colonnes deux variables liées à la position géographique des villes (Latitude et Longitude).


```{python}
# Chargement des données
import pandas as pd
Data = pd.read_excel("./donnee/temperature_acp.xlsx",sheet_name=0,index_col=0)

```

```{r temperature-data,engine='R',echo=FALSE}
knitr::kable(py$Data, 
             caption = "Données - Température des villes françaises",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::column_spec(c(13,17,18),border_right = TRUE) %>%
  kableExtra::row_spec(15,hline_after = TRUE) %>%
  kableExtra::kable_styling(position="center",
                            latex_options = c("striped", "hold_position","repeat_header","scale_down"))
```


# ACP

Le but général de l’étude est de comparer les températures mensuelles des différentes villes. D'une part du point de vue des villes, on pose les questions suivantes : Quelles sont les villes qui se ressemblent vis-à-vis de l’ensemble des variables (les mois). Quelles sont celles qui diffèrent. Plus généralement, peut-on faire une typologie des villes mettant en évidence l’ensemble des ressemblances ainsi définies?  D'autre part, du point de vue des mois : Quels mois sont corrélés entre eux ? Quels sont ceux qui le sont peu ? Plus généralement, peut-on faire un bilan de corrélation entre les 12 mois ? Les températures mensuelles sont-elles liées à la position géographique (variables supplémentaires)?

## Chargement de scientisttools

```{python}
from scientisttools.decomposition import PCA
```


On crée une instance de la classe PCA, en lui passant ici des étiquettes pour les lignes et les variables. Ces paramètres sont facultatifs ; en leur absence, le programme détermine automatiquement des étiquettes.

Le constructeur de la classe PCA possède un paramètre \texttt{normalize} qui indique si l'ACP est réalisée :

\begin{itemize}
\item à partir de données centrées et réduites -> PCA(normalize=True)
\item à partir de données centrées mais non réduites -> PCA(normalize=False)
\end{itemize}

Par défaut, la valeur du paramètre \texttt{normalize} est fixée à \texttt{True}, car c'est le cas le plus courant.

Réalisez l'ACP sur tous les individus (actifs et supplémentaires) et les variables (actives et supplémentaires)en tapant la ligne de code suivante :


```{python}
# ACP - Instanciation
res_pca = PCA(normalize=True,
              n_components = None,
              row_labels=Data.index[:15],
              col_labels=Data.columns[:12],
              row_sup_labels=Data.index[15:],
              quanti_sup_labels=["moy","amp","Lati","Long"],
              quali_sup_labels=["groupe"],
              parallelize=True).fit(Data)
```


# HCPC

La première étape consistait à réaliser une ACP du tableau de données. On réalise ensuite la classification hiérarchique. Nous demandons une partition en $3$ classes.

```{python}
from scientisttools.clustering import HCPC
res_hcpc = HCPC(n_clusters=3)
```

```{python}
# Entraînement du modèle
res_hcpc.fit(res_pca)
```

## Dendrogram

L'arbre hiérarchique nous montre notre partition en trois classes.

```{python}
# Plot dendodgram
from scientisttools.pyplot import plot_dendrogram
import matplotlib.pyplot as plt
fig,axe = plt.subplots(figsize=(16,8))
plot_dendrogram(res_hcpc,ax=axe,max_d=5)
plt.show()
```

## Plan factoriel

Le plan factoriel où les individus sont coloriés en fonction de la classe à laquelle ils appartiennent est le suivant :


```{python, fig.cap = "Plan factoriel",out.width="70%"}
# Plan factoriel
from plotnine import *
from scientisttools.ggplot import fviz_hcpc_cluster
p = (fviz_hcpc_cluster(res_hcpc,add_ellipse=False,repel=False,
                      show_clust_cent=False,center_marker_size=5)+theme_gray()+
    theme(legend_direction="vertical",legend_position=(0.2,0.3)))
print(p)
```

```{python}
# Statistiques sur les classes
cinfos =  res_hcpc.cluster_infos_
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$cinfos, 
             caption = "Statistiques sur les classes",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::kable_styling(font_size = 8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

En creusant plus en profondeur, on a la composition suivante :

\begin{itemize}
\item La classe $1$ (Les 5 villes méridionales) : Bordeaux, Marseille, Montpellier, Nice et Toulouse. 
\item La classe $2$ (les 3 villes les plus occidentales - à faible amplitude thermique) : Brest, Nantes et Rennes
\item La classe $3$ (les $7$ villes à forte amplitude thermique) : Clermont, Grenoble, Lille, Lyon, Paris, Strasbourg et Vichy.
\end{itemize}

## Description des classes

Les classes peuvent être décrites par : 

\begin{itemize}
\item les variables et/ou des modalités
\item les axes factoriels
\item les individus
\end{itemize}

### Moyenne par classe

```{python}
# Moyennes des variables par classe
gmean=res_hcpc.gmean_
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$gmean, 
             caption = "Moyennes des variables par classe",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::kable_styling(font_size = 8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

### Coordonnées des classes


```{python}
# Centre de gravité des classes
gclasse = res_hcpc.cluster_centers_
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$gclasse, 
             caption = "Centre de gravité",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::kable_styling(position="center",
                            latex_options = c("striped", "hold_position","repeat_header","scale_down"))
```

### Corrélation entre classe et variables

```{python}
# Rapport de correlation
eta2 = res_hcpc.correlation_ratio_
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$eta2, 
             caption = "Rapport de corrélation",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::kable_styling(font_size = 8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

###  Description par variables

```{python}
# Description par les variables quantitatives
vardesc = res_hcpc.desc_var_quanti_
# Pour un meilleur rendu
vardesc = (vardesc.reset_index()
                 .rename(columns={"level_0":"cluster","level_1" : "variable"}))
```



```{r var-desc,engine='R',echo=FALSE}
knitr::kable(py$vardesc,
             caption = "Description par les variables",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::row_spec(c(12,24),hline_after = TRUE) %>%
  kableExtra::kable_styling(position="center",
                            latex_options = c("striped", "hold_position","repeat_header","scale_down"))
```

Le tableau \ref{tab:var-desc} fournit directement les caractéristiques des classes. Nous les résumons en $3$ points :

\begin{enumerate}
\item Les individus de la classe $1$ sont caractérisés par une température élevée toute l'année, particulièrement en demi - saison. Ces villes sont méridionaales (faible latitude).

\item \og A l'opposé \fg{}, les individus de la classe $3$ sont caractérisés par une température faible toute l'année, particulièrement pendant les mois les plus froids.

\item La classe $2$ comporte des villes présentant une faible amplitude thermique; elles sont situées à l'ouest (faible longitude).
\end{enumerate}


### Description par les axes factoriels


```{python}
# Description par les axes factoriels
axinfos = res_hcpc.desc_axes_infos_
axinfos= (axinfos.reset_index()
                 .rename(columns={"level_0":"cluster","level_1" : "variable"}))
```


```{r,engine='R',echo=FALSE}
knitr::kable(py$axinfos,
             caption = "Description par les axes",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::row_spec(c(12,24),hline_after = TRUE) %>%
  kableExtra::kable_styling(position="center",
                            latex_options = c("striped", "hold_position","repeat_header","scale_down"))
```

Les individus de la classe $1$ possèdent de faibles coordonnées sur le premier axe. Ceux de la classe $2$ possèdent des coordonnées faibles sur le deuxième axe et les individus de la classe $2$ possèdent des coordonnées élevées sur les deux premiers axes.

### Description par les individus

Il existe deux types d'individus spécifiques pour décrire les classes : 

\begin{itemize}
\item Les individus les plus proches du centre de classe (le parangons)
\item Les individus les plus éloignés des centres des autres classes.
\end{itemize}


```{python}
# Individu proches
near = res_hcpc.disto_near_
near = (near.reset_index()
            .drop(columns=["level_1"])
            .rename(columns={"level_0":"cluster"}))
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$near,
             caption = "Description par les individus proches",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::row_spec(c(5,8),hline_after = TRUE) %>%
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


```{python}
### Individus loins
far = res_hcpc.disto_far_
far = (far.reset_index()
          .drop(columns=["level_1"])
          .rename(columns={"level_0":"cluster"}))
```


```{r,engine='R',echo=FALSE}
knitr::kable(py$far,
             caption = "Description par les individus éloignés",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::row_spec(c(5,8),hline_after = TRUE) %>%
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

`r py$near[1,2]` appartient à la classe $1$ et est le plus proche du centre de cette classe. De même, `r py$far[1,2]` appartient à la même classe et est le plus éloigné du centre de cette classe.

L'atttribut \texttt{.parangons\_} permet avoir les individus les plus proches du centre de gravité de chaque classe.

```{python}
# Parangons
para = res_hcpc.parangons_
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$para,
             caption = "Individus parangons",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


### Autres attributs

```{python}
# Correlation des variables suppélmentaires et le cluster
vsupeta2 = res_hcpc.correlation_ratio_quanti_sup_
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$vsupeta2,
             caption = "Rapport de corrélation variables supplémentaires quantitatives avec les axes factoriels",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


```{python}
# Rapport de corrélation avec les axes factoriels
axeta2 = res_hcpc.desc_axes_correlation_ratio_
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$axeta2,
             caption = "Rapport de corrélation avec les axes factoriels",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


```{python}
# Moyennes des axes par cluster
axgmean = res_hcpc.desc_axes_gmean_.T
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$axgmean,
             caption = "Centre de gravité",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::kable_styling(position="center",
                            latex_options = c("striped", "hold_position","repeat_header","scale_down"))
```

```{python}
vsupdesc = res_hcpc.desc_var_quanti_sup_
vsupdesc = (vsupdesc.reset_index()
                    .rename(columns={"level_0":"cluster","level_1" : "variable"}))
```


```{r,engine='R',echo=FALSE}
knitr::kable(py$vsupdesc,
             caption = "Description par les variables quantitatives supplémentaires",
             booktabs = TRUE,linesep = "") %>%
  kableExtra::row_spec(c(4,8),hline_after = TRUE) %>%
  kableExtra::kable_styling(position="center",
                            latex_options = c("striped", "hold_position","repeat_header","scale_down"))
```


```{python}
vqsup = res_hcpc.desc_var_quali_sup_
vqsup.keys()
```


```{python}
chi2 = vqsup["chi2"]
chi2
```


```{python}
# Likelihood-test
gtest = vqsup["gtest"]
gtest
```

```{python}
# Cramer's V statistic
vqsup["cramer"]
```


```{python}
# Tschuprow's T statistic
vqsup["tschuprow"]
```


```{python}
# Pearson statistic
vqsup["pearson"]
```


```{python}
# Distances d'agrégation
dist = res_hcpc.distances_
# Histogram
import numpy as np
fig,axe = plt.subplots(figsize=(16,8))
axe.bar(np.arange(1,len(dist)+1),sorted(dist,reverse=True),color = "black")
plt.show()
```


Pour plus d'informations sur la classification hiérarchique combinée avec une analyse factorielle (HCPC) sous scientisttools, consulter le notebook 

\href{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/hcpc_pca_autos2005.ipynb}{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/hcpc\_pca\_autos2005.ipynb}.

---
title: '**ACM sous Python avec scientisttools**'
author: "Duvérier DJIFACK ZEBAZE"
#date: "`r Sys.Date()`"
documentclass: article
geometry: "left=2.5cm,right=2.5cm,top=2.5cm,bottom=2.5cm, twoside=true"
fontsize: 11pt
line-height: 1.5
urlcolor: blue
linkcolor: blue
link-citations : yes
output: pdf_document
mainfont: Bookman Old Style
header-includes:
- \usepackage{pbox}
- \usepackage{caption}
- \usepackage{subcaption}
- \usepackage{natbib}
- \usepackage[utf8]{inputenc} # Caractères spéciaux
- \usepackage[french]{babel}
- \usepackage{amsmath, amsfonts, amssymb}   #Symboles mathématiques
- \usepackage{amsfonts}
# - \usepackage{minitoc} # [undotted] pour supprimer les pointillés
# - \mtcsetdepth{minitoc}{1} # 1 section, 2 sous-section 3 sous-sous-section
# - \mtcsettitle{minitoc}{Sommaire} # Changer le titre
- \usepackage{diagbox}
- \usepackage{lettrine}
- \usepackage[labelfont=bf]{caption}
- \captionsetup{font=scriptsize}
- \usepackage{booktabs}
- \usepackage{longtable}
- \usepackage{array}
- \usepackage{multirow}
- \usepackage{wrapfig}
- \usepackage{float}
- \usepackage{colortbl}
- \usepackage{pdflscape}
- \usepackage{tabu}
- \usepackage{threeparttable}
- \usepackage{threeparttablex}
- \usepackage[normalem]{ulem}
- \usepackage{makecell}
- \usepackage{xcolor}
- \usepackage{minitoc}
- \usepackage[Bjornstrup]{fncychap}
#- \usepackage[Conny]{fncychap} 
#- \usepackage[pdftex]{pict2e}
- \usepackage[dvipsnames]{xcolor}
- \usepackage{fourier-orns}
- \usepackage{fancyhdr}
- \usepackage{geometry}
- \geometry{a4paper,total={160mm,240mm},left=25mm,right=25mm,top=25mm,bottom=25mm}
- \usepackage[printsolution=true]{exercises}
- \usepackage{tikz}
---

```{r setup, include=FALSE}
library(reticulate)
library(knitr)
library(kableExtra)
knitr::opts_chunk$set(echo = TRUE,message=FALSE, warning=FALSE,fig.pos = "H",
                      out.extra = "",fig.align = "center",collapse =  FALSE,
                      highlight = TRUE)
```

Ce tutoriel a pour objectif de présenter rapidement les principales fonctionnalités offertes par le package \og scientisttools \fg{} pour réaliser une Analyse des Correspondances Multiples. 

<!-- https://www.normalesup.org/~carpenti/Notes/ACM-avec-R/Resultats-ACM-Factominer.pdf -->
<!-- https://marie-chavent.perso.math.cnrs.fr/wp-content/uploads/2013/10/TP5_ACM.pdf -->

# Présentation des données


Nous illustrons l'analyse des correspondances multiples à l'aide d'un exemple sur les données \og Races Canines \fg{} extraites de l'ouvrage de Tenenhaus.

```{python}
# Chargement des données
import pandas as pd
# Données actives
A = pd.read_excel("./donnee/races_canines_acm.xls",header=0,sheet_name=0,index_col=0)
# Individus supplémentaires
B = pd.read_excel("./donnee/races_canines_acm.xls",header=0,sheet_name=1,index_col=0)
# Variables qualitative supplémentaires
C = pd.read_excel("./donnee/races_canines_acm.xls",header=0,sheet_name=2,index_col=0)
# Variables quantitatives supplémentaires
D = pd.read_excel("./donnee/races_canines_acm.xls",header=0,sheet_name=3,index_col=0)
C.index = D.index = A.index
# Concaténation
Data = pd.concat([pd.concat([A,B],axis=0),C,D],axis=1)
Data.info()
```

Ces données décrivent les caractéristiques de $27$ races de chiens au moyen de variables qualitatives.

La première colonne du tableau \ref{tab:races-canines-data} correspond à l'identifiant des observations. Les $6$ premières variables sont considérés comme actives : Taille, Poids, Vélocité, Intelligence, Affection, Agressivité. La $7^{\text{ème}}$ variable \og Fonction \fg{} est considérée comme variable illustrative qualitative tandis que la $8^{\text{ème}}$ comme variable illustrative quantitative. Les modalités des différentes variables sont les suivantes :

\begin{itemize}
\item Taille, Poids, vélocité, intelligence : faible (-), moyenn (+), fort (++)
\item Affection, agressivité : faible (-), fort(+)
\item fonction : compagnie, chasse, utilité.
\end{itemize}

La variable cote est une variable que nous avons pris soins de créer afin d'illustrer le concept de variable illustrative quantitative en ACM.

```{r races-canines-data,engine='R',echo=FALSE}
knitr::kable(py$Data, 
             caption = "Données Races Canines",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::row_spec(27,hline_after = TRUE) %>% 
  kableExtra::column_spec(c(8,9),border_left = TRUE) %>% 
  kableExtra::kable_styling(position="center",
                            latex_options = c("striped", "hold_position","repeat_header","scale_down"))
```

Les principales questions auxquelles nous nous posons sont les suivantes :

\begin{itemize}
\item Quels sont les chiens qui se ressemblent? Quels sont les chiens qui sont dissemblables? (proximité entre les individus)
\item Sur quels caractères sont fondées ces ressemblances/dissemblances?
\item Quelles sont les associations entre les modalités? Par exemple, un animal de grande taille est - il plus agressif ou moins agressif?
\item Quelles sont les relations entre les variables? Par exemple y a-t-il une relation entre la taille et l'agressivité ou bien sont - ce des caractères orthogonaux.
\end{itemize}

A partir du tableau \ref{tab:races-canines-data}, on remarque que les paires de chiens (Bull - Dog, Teckel), (Chihuahua, Pékinois) et (Dalmatien, Labrador) sont des valeurs identiques pour les $7$ variables, il y aura donc des observations confondues.

A l'aide d'un diagramme à barres, nous visualisons nos différentes variables :


```{python}
# Diagramme à barres
import matplotlib.pyplot as plt
fig = plt.figure(figsize=(16,8))
for i, name in enumerate(A.columns):
  ax = fig.add_subplot(2,3,i+1)
  A[name].value_counts().plot.bar(ax=ax)
  ax.set(title=name)
  ax.grid(visible=True)
  plt.tight_layout()
```

# ACM

## Objectifs 

L'objectif est de trouver un système de représentation  (répère factoriel) qui préserve au mieux les distances entre les individus, qui permet de discerner le mieux possible les individus entre eux, qui maximise les (le carré des) écarts à l'origine.

## Chargement de scientisttools

```{python}
from scientisttools.decomposition import MCA
```

## Individus et variables actifs

On crée une instance de la classe MCA, en lui passant ici des étiquettes pour les lignes et les variables. Ces paramètres sont facultatifs ; en leur absence, le programme détermine automatiquement des étiquettes.

```{python}
# Instanciation
my_mca = MCA(n_components=None,
             row_labels=A.index,
             var_labels=A.columns,
             mod_labels=None,
             matrix_type="completed",
             benzecri=True,
             greenacre=True,
             row_sup_labels=None,
             quali_sup_labels=None,
             quanti_sup_labels=None,
             parallelize=False)
```

On estime le modèle en appliquant la méthode \texttt{fit} de la classe MCA sur le jeu de données.

```{python}
# Estimation du modèle
my_mca.fit(A)
```


### Les valeurs propres

L'exécution de la méthode \texttt{my\_mca.fit(A)} provoque le calcul des attributs parmi lesquels \texttt{my\_mca.eig\_} pour les valeurs propres.

```{python}
# Valeurs propres
print(my_mca.eig_)
```

L'attribut \texttt{my\_mca.eig\_} contient :

\begin{itemize}
\item en 1ère ligne : les valeurs propres en valeur absolue
\item en 2ème ligne : les différences des valeurs propres
\item en 3ème ligne : les valeurs propres en pourcentage de la variance totale (proportions)
\item en 4ème ligne : les valeurs propres en pourcentage cumulé de la variance totale.
\end{itemize}

La fonction \texttt{get\_eig} retourne les valeurs propres sous forme de tableau de données.

```{python}
# Valeurs propres
from scientisttools.extractfactor import get_eig
print(get_eig(my_mca))
```

Le nombre de modalités actives est $16 (3\times 4 + 2\times 2)$, ce qui conduit à $10$ facteurs et à une inertie totale de $\dfrac{16}{6}-1=\dfrac{5}{3}=1.667$.

Les valeurs propres peuvent être représentées graphiquement

```{python, out.width="90%"}
from scientisttools.ggplot import fviz_eigenvalue
print(fviz_eigenvalue(my_mca,choice="eigenvalue", add_kaiser=True))
```

```{python, out.width="90%"}
print(fviz_eigenvalue(my_mca,choice="proportion"))
```

Le critère de Kaiser conduit à ne retenir que trois axes, le diagramme des valeurs propres montre cependant une chute après $\lambda_{2}$. On interprètera donc uniquement les deux premiers axes.


### Correction de Benzécri

La correction de Benzécri s'appuie sur l'idée qu'une partie de l'information est rédondante dans les données présentées à l'algorithme de l'ACM.

```{python}
# Correction de Benzécri
my_mca.benzecri_correction_
```

### Correction de Greenacre

La correction de Greenacre s'appuie sur la correction de Benzécri mais reconsidère la proportion d'inertie portée par les facteurs.  Une partie de l'information est triviale dans le tableau de Burt, il s'agit du croisement endogène de chaque variable.

```{python}
# Correction de Greenacre
my_mca.greenacre_correction_
```


On peut obtenir un résumé des principaux résultats en utilisant la fonction \texttt{summaryMCA}.

```{python}
from scientisttools.extractfactor import summaryMCA
summaryMCA(my_mca)
```

## Représentation graphique

```{python,out.width="90%"}
# Carte des individus
from scientisttools.ggplot import fviz_mca_ind
print(fviz_mca_ind(my_mca,color="blue",repel=True))
```


```{python, out.width="90%"}
# Carte des modalités
from scientisttools.ggplot import fviz_mca_mod
print(fviz_mca_mod(my_mca,color="red",repel=True))
```

```{python, out.width="90%"}
# Carte des variables
from scientisttools.ggplot import fviz_mca_var
print(fviz_mca_var(my_mca,color="blue",repel=True))
```


# ACM avec les éléments supplémentaires

Les individus illustratifs et les variables illustratives n'influencent pas la construction des composantes principales de l'analyse. Ils/Elles aident à l'interprétation des dimensions de variabilité.

On peut ajouter deux types de variables : continues et qualitatives.

On ajoute la variable \og Cote \fg{} comme variable continue illustrative quantitative et \og Fonction \fg{} comme variable qualitative. Tapez la ligne de code suivante :

```{python}
# ACM avec les éléments supplémentaires
my_mca2 = MCA(n_components=None,
             row_labels=A.index,
             var_labels=A.columns,
             mod_labels=None,
             matrix_type="completed",
             benzecri=True,
             greenacre=True,
             row_sup_labels=B.index,
             quali_sup_labels=["Fonction"],
             quanti_sup_labels=["Cote"],
             parallelize=False)
# Estimation
my_mca2.fit(Data)
```


```{python,out.width="90%"}
# Carte des individus
from scientisttools.pyplot import plotMCA
fig, axe = plt.subplots(figsize=(10,10))
plotMCA(my_mca2,choice="ind",ind_sup=True,repel=True,ax=axe)
plt.show()
```

```{python,out.width="90%"}
# Carte des modalités
print(fviz_mca_mod(my_mca2,color="blue",repel=True))
```

# Interprétation des axes

Des graphiques qui permettent d'interpréter rapidement les axes : on choisit un axe factoriel (le 1er axe dans notre exemple) et on observe quels sont les points lignes et colonnes qui présentent les plus fortes contributions et cos2 pour cet axe.

```{python, out.width="90%"}
# Classement des points lignes en fonction de leur contribution au 1er axe
from scientisttools.pyplot import plot_contrib, plot_cosines
fig, axe = plt.subplots(figsize=(16,8))
plot_contrib(my_mca,choice="ind",axis=0,top_contrib=10,ax=axe)
plt.show()
```


```{python,out.width="90%"}
# Classement des modalités en fonction de leur contribution au 1er axe
fig, axe = plt.subplots(figsize=(16,8))
plot_contrib(my_mca,choice="mod",axis=0,ax=axe)
plt.show()
```

```{python,out.width="85%"}
# Classement des individus en fonction de leur cos2 sur le 1er axe
fig, axe = plt.subplots(figsize=(16,8))
plot_cosines(my_mca,choice="ind",axis=0,top_cos2=10,ax=axe)
plt.show()
```


```{python,out.width="85%"}
# Classement des modalités en fonction de leur cos2 sur le 1er axe
fig, axe = plt.subplots(figsize=(16,8))
plot_cosines(my_mca,choice="mod",axis=0,ax=axe)
plt.show()
```

# Approche Machine Learning

Ici, l'objectif est d'utiliser l'Analyse des Correspondances Multiples en tant que méthode de prétraitement.

La classe MCA implémente les méthodes \texttt{fit}, \texttt{transform} et \texttt{fit\_transform} bien connues des utilisateurs de scikit-learn.

```{python}
my_mca.transform(A)[:5,:]
```


```{python}
my_mca.fit_transform(A)[:5,:]
```


## Intégration dans une Pipeline de scikit-learn

La class MCA peut être intégrée dans une Pipeline de scikit-learn.
Dans le cadre de notre exemple, nous cherchons à prédire la 7ème variable (variable "Fonction") à partir des $6$ premières variables du jeu de données. 

"Fonction" est une variable catégorielle comprenant 3 catégories : "chasse", "compagnie" et "utilité". Pour la prédire, nous allons utiliser un modèle de régression logistique qui prendra en input des axes issus d'une Analyse des Correspondances Multiples pratiquée sur les données brutes.

Dans un premier temps, et de façon tout à fait arbitraire, nous fixons le nombre de composantes extraites à 4.

```{python}
from sklearn.pipeline import Pipeline
from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import GridSearchCV
import numpy as np

# X = features
X = A
# y = labels
y = C

# Construction de la Pipeline
# On enchaine une Analyse des Correspondances Multiples (4 axes retenus) 
# puis une régression logistique
pipe = Pipeline([("mca", MCA(n_components=4,var_labels=A.columns)), 
                 ("logistic_regression", 
                   LogisticRegression(multi_class="multinomial",
                                      solver="lbfgs",penalty=None))])
# Estimation du modèle
pipe.fit(X, y)
```

On prédit

```{python}
# Prédiction sur l'échantillon de test
print(pipe.predict(B))
```


Le paramètre \texttt{n\_components} peut faire l'objet d'une optimisation via GridSearchCV de scikit-learn.

Nous reconstruisons donc une Pipeline, sans spécifier de valeur a priori pour n_components.

```{python}
# Reconstruction d'une Pipeline, sans spécifier de valeur 
# a priori pour n_components
pipe2 = Pipeline([("mca", MCA(var_labels=A.columns)), 
                  ("logistic_regression", LogisticRegression(penalty=None))])
                  
# Paramétrage de la grille de paramètres
# Attention à l'étendue des valeurs possibles pour pca__n_components !!!
param = [{"mca__n_components": [x + 1 for x in range(10)]}]

# Construction de l'obet GridSearchCV
grid_search = GridSearchCV(pipe2, 
                           param_grid=param, 
                           scoring="accuracy",
                           cv=5,
                           verbose=0)
# Estimation du modèle
grid_search.fit(X, y)
```


```{python}
# Affichage du score optimal
grid_search.best_score_
```


```{python}
# Affichage du paramètre optimal
grid_search.best_params_
```

```{python}
# Prédiction sur l'échantillon de test
grid_search.predict(B)
```



Pour plus d'informations sur l'ACM sous scientisttools, consulter le notebook 

\href{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/mca_example.ipynb}{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/mca\_example.ipynb}.

---
title: '**ACD sous Python avec scientisttools**'
author: "Duvérier DJIFACK ZEBAZE"
#date: "`r Sys.Date()`"
documentclass: article
geometry: "left=2.5cm,right=2.5cm,top=2.5cm,bottom=2.5cm, twoside=true"
fontsize: 11pt
line-height: 1.5
urlcolor: blue
linkcolor: blue
link-citations : yes
output: pdf_document
mainfont: Bookman Old Style
header-includes:
- \usepackage{pbox}
- \usepackage{caption}
- \usepackage{subcaption}
- \usepackage{natbib}
- \usepackage[utf8]{inputenc} # Caractères spéciaux
- \usepackage[french]{babel}
- \usepackage{amsmath, amsfonts, amssymb}   #Symboles mathématiques
- \usepackage{amsfonts}
# - \usepackage{minitoc} # [undotted] pour supprimer les pointillés
# - \mtcsetdepth{minitoc}{1} # 1 section, 2 sous-section 3 sous-sous-section
# - \mtcsettitle{minitoc}{Sommaire} # Changer le titre
- \usepackage{diagbox}
- \usepackage{lettrine}
- \usepackage[labelfont=bf]{caption}
- \captionsetup{font=scriptsize}
- \usepackage{booktabs}
- \usepackage{longtable}
- \usepackage{array}
- \usepackage{multirow}
- \usepackage{wrapfig}
- \usepackage{float}
- \usepackage{colortbl}
- \usepackage{pdflscape}
- \usepackage{tabu}
- \usepackage{threeparttable}
- \usepackage{threeparttablex}
- \usepackage[normalem]{ulem}
- \usepackage{makecell}
- \usepackage{xcolor}
- \usepackage{minitoc}
- \usepackage[Bjornstrup]{fncychap}
#- \usepackage[Conny]{fncychap} 
#- \usepackage[pdftex]{pict2e}
- \usepackage[dvipsnames]{xcolor}
- \usepackage{fourier-orns}
- \usepackage{fancyhdr}
- \usepackage{geometry}
- \geometry{a4paper,total={160mm,240mm},left=25mm,right=25mm,top=25mm,bottom=25mm}
- \usepackage[printsolution=true]{exercises}
- \usepackage{tikz}
---

```{r setup, include=FALSE}
library(reticulate)
library(knitr)
library(kableExtra)
knitr::opts_chunk$set(echo = TRUE,message=FALSE, warning=FALSE,fig.pos = "H",
                      out.extra = "",fig.align = "center",collapse =  FALSE,
                      highlight = TRUE)
```

Ce tutoriel a pour objectif de présenter rapidement les principales fonctionnalités offertes par le package \og scientisttools \fg{} pour réaliser une Analyse des Correspondances Discriminante . 

<!-- https://scholar.google.com/citations?view_op=view_citation&hl=en&user=Tyd1NtYAAAAJ&cstart=20&pagesize=80&citation_for_view=Tyd1NtYAAAAJ:TFP_iSt0sucC -->

# Présentation des données

L'analyse des correspondances discriminante (ACD) est le pendant de l'analyse factorielle discriminante pour les descripteurs catégoriels. On la reconnaît sous les traits de l'analyse discriminante barycentrique. Lorsque le nombre de classes est supérieur à $2$, l'approche passe par un tableau de contingence particulier soumis à une analyse factorielle des correspondances (AFC).

## Importation des données

Nous illustrons l'analyse des correspondances discriminante à l'aide d'un exemple sur les données \og Races Canines \fg{} extraites de l'ouvrage de Tenenhaus. Il s'agit de prédire la variable \og Fonction \fg{} (utilite, chasse, compagnie) de $(n=27)$ chiens à partir de leurs caractéristiques (Taille, Poids, etc. 6 variables).


```{python}
# Chargement des données
import pandas as pd
# Données actives
DTrain = pd.read_csv("./donnee/races_canines.txt",sep="\t",encoding='latin-1',
                     index_col=0)
print(DTrain.info())
```


## Distribution relative

Nous calculons la distribution relative des classes :

```{python}
# Distribution relative des classes
d = (DTrain.Fonction.value_counts(normalize=True).reset_index()
                .rename(columns={"index":"Fonction","Fonction":"p(k)"}))
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$d, 
             caption = "Distribution relative des classes",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

## Analyse bivariée

Une première piste consiste à procéder à une simple analyse bivariée. Nous croisons chaque descripteur avec la variable cible. Nous disposons ainsi d'une première indication sur les liaisons individuelles de chaque descripteur avec \og Fonction \fg{}.

```{python}
# V de Cramer
import scientistmetrics as st
cramerV = st.scientistmetrics(DTrain)
cramerV = (cramerV.iloc[:6,6].to_frame()
                  .sort_values(by="Fonction",ascending=False).T)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$cramerV, 
             caption = "V de Cramer entre la cible et les descripteurs",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Nous avons quelques relations qui sont assez fortes :  `r colnames(py$cramerV)[1]` avec un V de Cramer de `r round(py$cramerV[1,1],2)`; `r colnames(py$cramerV)[2]` avec un V de Cramer de `r round(py$cramerV[1,2],2)`; `r colnames(py$cramerV)[3]` avec un V de Cramer de `r round(py$cramerV[1,3],2)` et `r colnames(py$cramerV)[4]` avec un V de Cramer de `r round(py$cramerV[1,4],2)`. Il semble donc possible d'expliquer la fonction des chiens à partir de leurs caractéristiques. Mais il faut le faire de manière multivariée c'est - à - dire en tenant compte du rôle simultané de l'ensemble des descripteurs.

# Analyse avec scientisttools

## Modélisation avec scientisttools

Sage précaution avec les packages pour Python, nous affichons le numéro de la version de \og scientisttools \fg{} utilisée dans ce tutoriel. 

```{python}
# version
import scientisttools
print(scientisttools.__version__)
```

Nous fonctionnons avec la version \og 0.0.9 \fg{}.

```{python}
# Importation
from scientisttools.discriminant_analysis import DISCA
```

On crée une instance de la classe DISCA, en lui passant ici des étiquettes pour les variables explicatives et la variable cible. 

```{python}
# Instanciation
disca = DISCA(n_components=None,
              target=["Fonction"],
              features_labels=DTrain.columns[:-1].values,
              matrix_type="completed",
              priors=None,
              parallelize=False)
```

On estime le modèle en appliquant la méthode \texttt{.fit} de la classe DISCA sur le jeu de données.

```{python}
# Entraînement du modèle
disca.fit(DTrain)
```

## Inspection de l'objet DISCA

\begin{itemize}
\item \texttt{priors\_} correspond à la distribution relative des classes.
\end{itemize}

```{python,eval=FALSE}
# distribution des classes
print(lda.priors_)
```


```{r,engine='R',echo=FALSE}
knitr::kable(t(py$disca$priors_), 
             caption = "Distribution relative pour chaque classe",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

\begin{itemize}
\item \texttt{statistics\_test\_} correspond aux tests statistiques entre variables qualitatives
\end{itemize}

```{python}
# Tests statistiques
stats_test = disca.statistics_test_
print(stats_test.keys())
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$disca$statistics_test_$chi2, 
             caption = "Test statistique de chi2",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

\begin{itemize}
\item \texttt{mod\_stats} correspond à la distribution absolue et relative des classes 
\end{itemize}

```{python,eval=FALSE}
# distribution absolue et relative des classes
print(disca.mod_stats)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$disca$mod_stats, 
             caption = "Distribution absolue et relative pour chaque classe",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

# Analyse des classes

##  Coordonnées des classes

L'objet \og disca \fg{} fournit les coordonnées des points - classes.

```{python,eval=FALSE}
# Coordonnées des points - classes
disca.gcoord_
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$disca$gcoord_, 
             caption = "Coordonnées factorielles des classes",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

On projette ces points - classes dans le plan :

```{python gcoord,fig.cap="Carte des points - classes",out.width="50%"}
# Projection des points classes
from plotnine import *
gcoord = disca.gcoord_
p = (ggplot(gcoord,aes(x="Dim.1",y="Dim.2",label=gcoord.index))+
        geom_point(aes(color=gcoord.index))+
        geom_text(aes(color=gcoord.index),
                  adjust_text={'arrowprops': {'arrowstyle': '-','lw':1.0}})+
        geom_hline(yintercept=0,colour="black",linetype="--")+
        geom_vline(xintercept=0,colour="black",linetype="--")+
        theme(legend_direction="vertical",legend_position=(0.2,0.7))+
        labs(color="Fonction"))
print(p)
```

Visiblement, \og compagnie \fg{} et \og utilite \fg{} s'opposent sur le premier facteur. \og chasse \fg{} se démarque des deux autres sur le second facteur.

## Distances entre centres de classes

Les distances entre centres de classes permettent de situer les proximités entre les groupes sur l'ensemble des facteurs. La distance euclidienne entre les classes dans le répère factoriel est la suivante :

```{python}
# Distance euclidienne
DE = pd.DataFrame(disca.ca_model_.row_dist_,columns=disca.classes_,
                  index=disca.classes_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$DE, 
             caption = "Distance euclidienne entre les classes",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Les trois types de fonctions forment un triangle approximativement isocèle dans le plan factoriel.

Ajoutons ces distances sur le plan factoriel :

```{python fig.cap="Carte des points - classes",out.width="50%"}
# Projection des points classes avec distances entre classes
p = (ggplot(gcoord,aes(x="Dim.1",y="Dim.2",label=gcoord.index))+
        geom_point(aes(color=gcoord.index))+
        geom_text(aes(color=gcoord.index),
                  adjust_text={'arrowprops': {'arrowstyle': '-','lw':1.0}})+
        geom_hline(yintercept=0,colour="black",linetype="--")+
        geom_vline(xintercept=0,colour="black",linetype="--")+
        theme(legend_direction="vertical",legend_position=(0.2,0.7))+
        annotate("segment",x=gcoord.iloc[0,0],y=gcoord.iloc[0,1],
                           xend=gcoord.iloc[1,0],yend=gcoord.iloc[1,1],
                           color="blue")+
        annotate("segment",x=gcoord.iloc[0,0],y=gcoord.iloc[0,1],
                           xend=gcoord.iloc[2,0],yend=gcoord.iloc[2,1],
                           color="blue")+
        annotate("segment",x=gcoord.iloc[1,0],y=gcoord.iloc[1,1],
                           xend=gcoord.iloc[2,0],yend=gcoord.iloc[2,1],
                           color="blue")+
        # Add test
        annotate('text', x = -0.3, y = 0.2,label = DE.iloc[0,1].round(2),
                 size = 10, angle='35')+
        annotate('text', x = 0.4, y = 0.2,label = DE.iloc[0,2].round(2),
                 size = 10, angle='-60')+
        annotate('text', x = 0, y = -0.25,label = DE.iloc[2,1].round(2),
                 size = 10, angle='-10')+
        labs(color="Fonction"))
print(p)
```


## Qualité de la représentation des classes

Il suffit de passer les coordonnées au carré et de diviser par la somme en ligne. Sous scientisttools, elles correspondent à la qualité de représentation des points - lignes de l'analyse factorielle des correspondances.

```{python}
# Qualité de représentation
gcos2 = pd.DataFrame(disca.ca_model_.row_cos2_,
                     index=disca.ca_model_.row_labels_,
                     columns = disca.ca_model_.dim_index_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$gcos2, 
             caption = "Qualité de représentation des classes - COS2",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Le graphique (Figure \ref{fig:gcoord}) ne laissait aucun doute, mais c'est toujours mieux quand les chiffres confirment : les informations portées par \og compagnie \fg{} et \og utilite \fg{} sont bien captées par le premier facteur. \og chasse \fg{} est mieux situé sur le second facteur. Et la somme en ligne dans le tableau des COS2 fait bien $100\%$.

## Contributions des classes

Sous scientisttools, elles correspondent aux contributions des points - lignes de l'analyse factorielle des correspondances.

```{python}
# Contribution des groupes
gcontrib = pd.DataFrame(disca.ca_model_.row_contrib_,
                        index=disca.ca_model_.row_labels_,
                         columns = disca.ca_model_.dim_index_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$gcontrib, 
             caption = "Contributions des classes",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


Le premier axe oppose les fonctions \og compagnie \fg{} et \og utilite \fg{}. Elles déterminent (\textbf{contributions} = `r round(py$gcontrib[2,1],2)`$\%$ $+$ `r round(py$gcontrib[3,1],2)`$\%$) `r round(sum(py$gcontrib[c(2:3),1]),2)`$\%$ de l'information portée par le facteur. Elles sont aussi très bien représentées puisque `r round(100*py$gcos2[2,1],2)`$\%$ (resp. `r round(100*py$gcos2[3,1],2)`$\%$) de l'information véhiculée par \og compagnie \fg{} (resp. \og utilite \fg{}) est restrancrite sur cet axe.

Le second axe permet surtout de distinguer la fonction \og chasse \fg{} des deux premiers.

# Structures canoniques

Les structures canoniques correspondent aux représentations des modalités colonnes du tableau de contingence - et donc des modalités des variables prédictives - dans le répère factoriel.

## Poids, distance à l'origine et inertie

```{python}
# Informations sur les modalités
from scientisttools.extractfactor import get_ca_col
mod_infos = get_ca_col(disca.ca_model_)["infos"]
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$mod_infos, 
             caption = "Caractéristiques des modalités",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


## Coordonnées des points modalités

Les coordonnées des points modalités sont fournies par l'objet \texttt{ca\_model\_}.


```{python}
# Coordonnées des points modalités
mod_coord = pd.DataFrame(disca.ca_model_.col_coord_,
                         index=disca.ca_model_.col_labels_,
                         columns = disca.ca_model_.dim_index_)
```


```{r,engine='R',echo=FALSE}
knitr::kable(py$mod_coord, 
             caption = "Coordonnées des points modalités",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


```{python modcoord,fig.cap="Carte des points - modalités",out.width="50%"}
# Ajout de la variable
modcoord = mod_coord.copy()
modcoord.loc[:,"variable"] = [x.split("_")[0] for x in mod_coord.index]

# Projection des points modalités
p = (ggplot(modcoord,aes(x="Dim.1",y="Dim.2",label=mod_coord.index))+
        geom_point(aes(color=modcoord.variable))+
        geom_text(aes(color=modcoord.variable),
                  adjust_text={'arrowprops': {'arrowstyle': '-','lw':1.0}})+
        geom_hline(yintercept=0,colour="black",linetype="--")+
        geom_vline(xintercept=0,colour="black",linetype="--")+
        theme(legend_direction="vertical",legend_position=(0.2,0.2))+
        labs(color="Variable"))
print(p)
```

## Contributions des points modalités aux facteurs

Les contributions des points modalités sont :

```{python}
# Contributions des points modalités
mod_contrib = pd.DataFrame(disca.ca_model_.col_contrib_,
                         index=disca.ca_model_.col_labels_,
                         columns = disca.ca_model_.dim_index_)
```


```{r,engine='R',echo=FALSE}
knitr::kable(py$mod_contrib, 
             caption = "Contribution des points modalités",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


# Affectation des classes

## Fonction discriminante canonique

L'exécution de la méthode \texttt{disca.fit(DTrain)} provoque le calcul de plusieurs attributs parmi lesquels \texttt{disca.coef\_}. Ce champ nous intéresse particulièrement car il correspond aux coefficients des fonctions de classement. Ces fonctions canoniques permettent de projeter des individus non étiquetés dans l'espace factoriel.

```{python,eval=FALSE}
# Coefficients des fonctions discriminantes canoniques
print(disca.coef_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$disca$coef_, 
             caption = "Coefficients des fonctions discriminantes canoniques",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

## Coordonnées des individus

A partir des fonctions discriminantes canoniques, on détermine les coordonnées des individus.

```{python}
# Coordonnées factorielles des individus
row_coord = disca.row_coord_
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$disca$row_coord_, 
             caption = "Coordonnées des individus",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


```{python rowcoord,fig.cap="Carte des individus",out.width="50%"}
# Ajout de la colonne Fonction
rowcoord = pd.concat([row_coord,DTrain["Fonction"]],axis=1)
# Projection des points modalités
p = (ggplot(rowcoord,aes(x="Dim.1",y="Dim.2",label=rowcoord.index))+
        geom_point(aes(color=rowcoord.Fonction))+
        geom_text(aes(color=rowcoord.Fonction),
                  adjust_text={'arrowprops': {'arrowstyle': '-','lw':1.0}})+
        geom_hline(yintercept=0,colour="black",linetype="--")+
        geom_vline(xintercept=0,colour="black",linetype="--")+
        theme(legend_direction="vertical",legend_position=(0.5,0.2))+
        labs(color="Fonction")+
        annotate("text",x=gcoord["Dim.1"].values,y=gcoord["Dim.2"].values,
                 label=gcoord.index,color=["red","green","violet"]))
print(p)
```

## Valeurs propres associées aux facteurs

Les valeurs propres associées aux facteurs sont celles issues de l'analyse factorielle des correspondances.

```{python}
# Valeurs propres
from scientisttools.extractfactor import get_eigenvalue
eig = get_eigenvalue(disca.ca_model_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$eig, 
             caption = "Valeurs propres associées aux facteurs",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size = 8,
                            position = "center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

La valeur propre $(\lambda)$ indique l'inertie (la variance) expliquée par l'appartenance aux groupes sur chaque axe. En les additionnant, nous avons l'inertie expliquée par l'appartenance aux groupes dans l'espace complet soit `r sum(py$eig[,1])`. Cette inertie indique la quantité d'information que l'on peut modéliser dans la relation entre la cible Fonction et les descripteurs. Le premier facteur explique `r round(py$eig[1,3],2)`$\%$ de l'inertie totale.

On peut représenter graphiquement ces valeurs propres

```{python,fig.cap = "Scree plot",out.width="50%"}
# Scree plot
from scientisttools.ggplot import fviz_screeplot
p = fviz_screeplot(disca.ca_model_,choice="proportion",add_labels=True)
print(p)
```

## Rapport de corrélation

Le champ \texttt{correlation\_ratio\_} correspond aux carrés des rapports de corrélation.

```{python,eval=FALSE}
# Rapport de corrélation
print(disca.correlation_ratio_)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$disca$correlation_ratio_, 
             caption = "Rapport de correlation",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size = 8,
                            position = "center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


Le rapport de corrélation est le ratio entre la variance expliquée par l'appartenance aux groupes et la vaiance totale de l'axe. Il indique la qualité de discrimination des classes sur le facteur. Nous avons $\eta_{1}^{2}$ = `r py$disca$correlation_ratio_[1,1]`, c'est - à - dire `r round(100*py$disca$correlation_ratio_[1,1],2)`$\%$ de la variabilité des observations est expliquée par l'appartenance aux groupes sur le premier facteur. L'indicateur varie entre $0$ (discrimination nulle, les sous - populations sont complètement mélangées) et $1$ (discrimination parfaite, elles sont agglutinées) sur les centres de classes qui sont distincts les uns des autres.


## Corrélation canonique

La corrélation canonique est la racine carré du rapport de corrélation.

```{r,engine='R',echo=FALSE}
knitr::kable(sqrt(py$disca$correlation_ratio_), 
             caption = "Corrélation canonique",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size = 8,
                            position = "center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```



# Traitement d'individus supplémentaires

Les fonctions discriminantes canoniques nous permettent de positionner les individus suppémentaires dans le répère factoriel.

## Importation des données

Nous chargeons les individus supplémentaires.

```{python}
# Individus supplémentaires
Dsup = pd.read_excel("./donnee/races_canines_acm.xls",
                     header=0,sheet_name=1,index_col=0)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$Dsup, 
             caption = "Individus supplémentaires",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size = 8,
                            position = "center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

## Coordonnées des individus supplémentaires

L'objet \og DISCA \fg{} contient la fonction \texttt{transform()} bien connue des utilisateurs de scikit-learn. Elle permet d'obtenir les coordonnées des individus dans l'espace factoriel.

```{python}
# Coordonnées des individus supplémentaires
row_sup_coord = disca.transform(Dsup)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$row_sup_coord, 
             caption = "Coordonnées des individus supplémentaires",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size = 8,
                            position = "center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

On rajoute ces individus au plan factoriel

```{python,fig.cap="Carte des individus",out.width="50%"}
# Projection des points modalités
p = (ggplot(rowcoord,aes(x="Dim.1",y="Dim.2",label=rowcoord.index))+
        geom_point(aes(color=rowcoord.Fonction))+
        geom_text(aes(color=rowcoord.Fonction),
                  adjust_text={'arrowprops': {'arrowstyle': '-','lw':1.0}})+
        geom_hline(yintercept=0,colour="black",linetype="--")+
        geom_vline(xintercept=0,colour="black",linetype="--")+
        theme(legend_direction="vertical",legend_position=(0.5,0.2))+
        labs(color="Variable")+
        annotate("text",x=row_sup_coord["Dim.1"].values,
                        y=row_sup_coord["Dim.2"].values,
                    label=row_sup_coord.index))
print(p)
```

## Distances euclidiennes aux classes

La fonction \texttt{decision\_function()} permet de calculer les distances euclidiennes aux centres de classes.

```{python}
# Distances euclidiennes aux classes
disca.decision_function(Dsup)
```


## Probabilités d'affectation

L'objet \og scientisttools \fg{} calcule les probabilités d'affectation aux classes avec \texttt{predict\_proba()}.

```{python}
# probabilité d'affectation
print(disca.predict_proba(Dsup))
```

## Prédiction

On effectue la prédiction à partir de la matrice des explicatives des individus supplémentaires.

```{python}
# Prediction des individus supplémentaires
ypred = disca.predict(Dsup)
ypred
```

---
title: '**ACP sous Python avec scientisttools**'
author: "Duvérier DJIFACK ZEBAZE"
#date: "`r Sys.Date()`"
documentclass: article
geometry: "left=2.5cm,right=2.5cm,top=2.5cm,bottom=2.5cm, twoside=true"
fontsize: 11pt
line-height: 1.5
urlcolor: blue
linkcolor: blue
link-citations : yes
output: pdf_document
mainfont: Bookman Old Style
header-includes:
- \usepackage{pbox}
- \usepackage{caption}
- \usepackage{subcaption}
- \usepackage{natbib}
- \usepackage[utf8]{inputenc} # Caractères spéciaux
- \usepackage[french]{babel}
- \usepackage{amsmath, amsfonts, amssymb}   #Symboles mathématiques
- \usepackage{amsfonts}
# - \usepackage{minitoc} # [undotted] pour supprimer les pointillés
# - \mtcsetdepth{minitoc}{1} # 1 section, 2 sous-section 3 sous-sous-section
# - \mtcsettitle{minitoc}{Sommaire} # Changer le titre
- \usepackage{diagbox}
- \usepackage{lettrine}
- \usepackage[labelfont=bf]{caption}
- \captionsetup{font=scriptsize}
- \usepackage{booktabs}
- \usepackage{longtable}
- \usepackage{array}
- \usepackage{multirow}
- \usepackage{wrapfig}
- \usepackage{float}
- \usepackage{colortbl}
- \usepackage{pdflscape}
- \usepackage{tabu}
- \usepackage{threeparttable}
- \usepackage{threeparttablex}
- \usepackage[normalem]{ulem}
- \usepackage{makecell}
- \usepackage{xcolor}
- \usepackage{minitoc}
- \usepackage[Bjornstrup]{fncychap}
#- \usepackage[Conny]{fncychap} 
#- \usepackage[pdftex]{pict2e}
- \usepackage[dvipsnames]{xcolor}
- \usepackage{fourier-orns}
- \usepackage{fancyhdr}
- \usepackage{geometry}
- \geometry{a4paper,total={160mm,240mm},left=25mm,right=25mm,top=25mm,bottom=25mm}
- \usepackage[printsolution=true]{exercises}
- \usepackage{tikz}
---

```{r setup, include=FALSE}
library(reticulate)
library(knitr)
library(kableExtra)
knitr::opts_chunk$set(echo = TRUE,message=FALSE, warning=FALSE,fig.pos = "H",
                      out.extra = "",fig.align = "center",collapse =  FALSE,
                      highlight = TRUE)
```

Ce tutoriel a pour objectif de présenter rapidement les principales fonctionnalités offertes par le package \og scientisttools \fg{} pour réaliser une Analyse en Composantes Principales. 

# Présentation des données

On utilise ici l'exemple du tableau de données décathlon qui contient les performances réalisées par des athlètes lors de deux compétitions.

Vous pouvez charger le jeu de données \href{http://factominer.free.fr/factomethods/datasets/decathlon.txt}{http://factominer.free.fr/factomethods/datasets/decathlon.txt}.

```{python}
# Importation des données
from plydata import *
import pandas as pd
url = "http://factominer.free.fr/factomethods/datasets/decathlon.txt"
decathlon = pd.read_table(url,header=0)
decathlon.info()
```

```{r decathlon-data,engine='R',echo=FALSE}
knitr::kable(py$decathlon, 
             caption = "Données Decathlon",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(position="center",
                            latex_options = c("striped", "hold_position","repeat_header","scale_down"))
```

Le tableau de données contient $41$ lignes et $13$ colonnes (\emph{cf.} Table \ref{tab:decathlon-data}). Les colonnes de $1$ à $12$ sont des variables continues : les dix premières colonnes correspondent aux performances des athlètes pour les dix épreuves du décathlon et les colonnes 11 et 12 correspondent respectivement au rang et au nombre de points obtenus. La dernière colonne est une variable qualitative correspondant au nom de la compétition (Jeux Olympiques de 2004 ou Décastar 2004).

Pour une meilleure manipulation des colonnes dans Python, nous remplaçons les points sur les colonnes par les tirets de $8$.

```{python}
# Renommer les colonnes
decathlon.columns = [x.replace(".","_") for x in decathlon.columns]
decathlon.info()
```


Il est important de s’assurer que l’importation a bien été effectuée, et notamment que les variables quantitatives sont bien considérées comme quantitatives et les variables qualitatives bien considérées comme qualitatives.

```{python}
# Variable continues
import numpy as np
stat1 = decathlon.describe(include=np.number).T
```

```{r,engine='R',echo=FALSE}
knitr::kable(round(py$stat1,3), 
             caption = "Statistiques descriptives sur les variables continues",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


```{python}
stat2 = (decathlon.describe(include=["O"])
                  .reset_index()
                  .rename(columns={"index":"infos"}))
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$stat2, 
             caption = "Statistiques descriptives sur la variable catégorielle",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```


# Objectifs

L'ACP permet de décrire un jeu de données, de le résumer, d'en réduire la dimensionnalité.
L'ACP réalisée sur les individus du tableau de données répond à différentes questions :

\begin{enumerate}
\item Etude des individus (i.e. des athlètes) : deux athlètes sont proches s'ils ont des résultats similaires. On s'intéresse à la variabilité entre individus. Y a-t-il des similarités entre les individus pour toutes les variables ? Peut-on établir des profils d'athlètes ? Peut-on opposer un groupe d'individus à un autre ?
\item Etude des variables (i.e. des performances) : on étudie les liaisons linéaires entre les variables. Les objectifs sont de résumer la matrice des corrélations et de chercher des variables synthétiques: peut-on résumer les performances des athlètes par un petit nombre de variables ?
\item Lien entre les deux études : peut-on caractériser des groups d'individus par des variables ?
\end{enumerate}

# ACP

On étudie les profils d'ahtlètes uniquement en fonction de leur performance. Les variables actives ne seront donc que celles qui concernent les dix épreuves du décathlon.
Les autres variables ("\emph{Rank}", "\emph{Points}" et "\emph{Competition}") n'appartiennent pas aux profils d'athlètes et utilisent une information déjà donnée par les autres variables (dans le cas de "\emph{Rank}"et "\emph{Points}") mais il est intéressant de les confronter aux composantes principales. Nous les utiliserons comme variables illustratives.

Dans ce tableau de données, les variables ne sont pas mesurées dans les mêmes unités. On doit les réduire de façon à donner la même influence à chacune.

# Chargement de scientisttools

```{python}
from scientisttools.decomposition import PCA
```

# Individus et variables actifs


On crée une instance de la classe PCA, en lui passant ici des étiquettes pour les lignes et les variables. Ces paramètres sont facultatifs ; en leur absence, le programme détermine automatiquement des étiquettes.

Le constructeur de la classe PCA possède un paramètre \texttt{normalize} qui indique si l'ACP est réalisée :

\begin{itemize}
\item à partir de données centrées et réduites -> PCA(normalize=True)
\item à partir de données centrées mais non réduites -> PCA(normalize=False)
\end{itemize}

Par défaut, la valeur du paramètre \texttt{normalize} est fixée à \texttt{True}, car c'est le cas le plus courant.

Réalisez l'ACP sur tous les individus et seulement les variables actives (i.e. les dix premières) en tapant la ligne de code suivante :


```{python}
# Données actives
actif = decathlon[decathlon.columns[:10]]
# ACP sur les données actives uniquement - Instanciation du modèle
res_pca = PCA(normalize=True,
              n_components = None,
              row_labels=actif.index,
              col_labels=actif.columns,
              row_sup_labels=None,
              quanti_sup_labels=None,
              quali_sup_labels=None,
              parallelize=False)
```

\begin{itemize}
\item \texttt{normalize} :  pour choisir de réduire ou non les variables
\item \texttt{n\_components} : le nombre de dimensions à garder dans les résultats
\item \texttt{row\_labels} : les noms des lignes actives
\item \texttt{col\_labels} : les noms des colonnes actives
\item \texttt{row\_sup\_labels} : les nombes des lignes supplémentaires
\item \texttt{quanti\_sup\_labels} : les noms des colonnes quantitatives supplémentaires
\item \texttt{quali\_sup\_labels} : les noms des colonnes qualitatives supplémentaires
\item \texttt{parallelize} : paralleliser l'algorithme.
\end{itemize}

On estime le modèle en appliquant la méthode \texttt{.fit} de la classe PCA sur le jeu de données.

```{python}
# Entraînement du modèle
res_pca.fit(actif)
```

L'exécution de la méthode \texttt{res\_pca.fit(actif)} provoque le calcul de plusieurs attributs parmi lesquels \texttt{res\_pca.eig\_}.

```{python}
print(res_pca.eig_)
```


L'attribut \texttt{res\_pca.eig\_} contient :

\begin{itemize}
\item en 1ère ligne : les valeurs propres en valeur absolue
\item en 2ème ligne : les différences des valeurs propres
\item en 3ème ligne : les valeurs propres en pourcentage de la variance totale (proportions)
\item en 4ème ligne : les valeurs propres en pourcentage cumulé de la variance totale.
\end{itemize}

La fonction \texttt{get\_eig} retourne les valeurs propres sous forme de tableau de données.

```{python}
# Valeurs propres
from scientisttools.extractfactor import get_eig
print(get_eig(res_pca))
```


Les deux premières dimensions contiennent $50\%$ de l'inertie totale (l'inertie est la variance totale du tableau de données, i.e. la trace de la matrice des corrélations).

Les valeurs propres peuvent être représentées graphiquement :

```{python}
from scientisttools.ggplot import fviz_eigenvalue
print(fviz_eigenvalue(res_pca,choice="eigenvalue"))
```

```{python}
print(fviz_eigenvalue(res_pca,choice="proportion"))
```

On peut obtenir un résumé des principaux résultats en utilisant la fonction \texttt{summaryPCA}.

```{python}
from scientisttools.extractfactor import summaryPCA
summaryPCA(res_pca)
```

# Représentation graphique

```{python,out.width="90%"}
# Carte des individus
from scientisttools.ggplot import fviz_pca_ind
print(fviz_pca_ind(res_pca,repel=True))
```

```{python, out.width="90%"}
# Cercle des corrélations
from scientisttools.ggplot import fviz_pca_var
print(fviz_pca_var(res_pca))
```

La variable "X100m" est négativement corrélée à la variable "long\_jump". Quand un ahtlète réalise un temps faible au 100m, il peut sauter loin. Il faut faire attention ici qu'une petite valeur pour les variables "X100m", "X400m", "X110m\_hurdle" et "X1500m" correspond à un score élevé : plus un athlète court rapidement, plus il gagne de points.

Le premier axe oppose les athlètes qui sont "bons partout" comme Karpov pendant les Jeux Olympiques à ceux qui sont "mauvais partout" comme Bourguignon pendant le Décastar. Cette dimension est particulièrement liée aux variables de vitesse et de saut en longueur qui constituent un groupe homogène.

Le deuxième axe oppose les athlètes qui sont forts (variables "Discus" et "Shot\_put") à ceux qui ne le sont pas.
Les variables "Discus", "Shot\_put" et "High\_jump" ne sont pas très corrélées aux variables "X100m", "X400m", "X110m\_hurdle" et "Long\_jump". Cela signifie que force et vitesse ne sont pas très corrélées.

A l'issue de cette première approche, on peut diviser le premier plan factoriel en quatre parties : les athlètes rapides et puissants (comme Sebrle), les athlètes lents (comme Casarsa), les athlètes rapides mais faibles (comme Warners) et les ahtlètes ni forts ni rapides, relativement parlant (comme Lorenzo).

# ACP avec les variables illustratives

Les variables illustratives n'influencent pas la construction des composantes principales de l'analyse. Elles aident à l'interprétation des dimensions de variabilité.

On peut ajouter deux types de variables : continues et qualitatives.

On ajoute les variables "Rank" and "Points" comme variables continues illustratives quantiatives et "Competition" comme variable qualitative illustrative. Tapez la ligne de code suivante :

```{python}
res_pca = PCA(normalize=True,
              n_components = None,
              row_labels=decathlon.index,
              col_labels=actif.columns,
              row_sup_labels=None,
              quanti_sup_labels=["Rank","Points"],
              quali_sup_labels=["Competition"],
              parallelize=False)
res_pca.fit(decathlon)
```


```{python}
from scientisttools.pyplot import plotPCA
import matplotlib.pyplot as plt
fig, axe = plt.subplots(figsize=(10,10))
plotPCA(res_pca,choice="var",color="blue",quanti_sup=True,ax=axe,repel=True)
plt.show()
```



Les gagnants du décathlon sont ceux qui marquent le plus de points (ou ceux dont le rang est faible).
Les variables les plus liées au nombre de points sont les variables qui réfèrent à la vitesse ("X100m", "X110m\_hurdle", "X400m") et au saut en longueur. Au contraire, "Pole-vault" et "X1500m" n'ont pas une grande influence sur le nombre de points. Les athlètes qui sont bons à ces deux épreuves ne sont pas favorisés.

On ajoute la variable "Competition" comme variable qualitative illustrative.

```{python}
print(fviz_pca_ind(res_pca,repel=True))
```

Les centres de gravité des modalités de cette variable supplémentaire apparaissent sur le graphe des individus. Ils sont localisés au barycentre des individus qui les possèdent et représentent un individu moyen.

On peut également colorier les individus selon la couleur des centres de gravité des modalités :

```{python}
fig, axe = plt.subplots(figsize=(10,10))
plotPCA(res_pca,repel=True,ax=axe,random_state=123,habillage="Competition")
plt.show()
```

En regardant les points qui représentent "Decastar" et "Olympic Games", on voit que "Olympic Games" a une coordonnée plus élevée sur le premier axe que "Decastar". Ceci montre une évolution des performances des athlètes. Tous les athlètes qui ont participé aux deux compétitions ont obtenu des résultats légèrement meilleurs aux jeux Olympiques.

Cependant, il n'y a aucune différence entre les points "Decastar" et "Olympic Games" sur le deuxième axe. Cela signifie que les athlètes ont amélioré leurs performances mais n'ont pas changé de profil (à l'exception de Zsivoczky qui est passé de lent et fort pendant le Décastar à rapide et faible pendant les Jeux Olympiques).

Les points qui représentent un même individu vont dans le même direction. Par exemple, Sebrle a obtenu de bons résultats aux deux compétitions mais le point qui représente sa performance aux J.O. est plus extrême. Sebrle a obtenu plus de points pendant les J.O. que pendant le Décastar..

On peut envisager deux interprétations :
\begin{enumerate}
\item Les athlètes qui participent aux J.O. sont meilleurs que ceux qui participent au Décastar
\item Les athlètes font de leur mieux aux J.O. (plus motivés, plus entraînés)
\end{enumerate}

```{python}
summaryPCA(res_pca)
```

# Graphes sur les dimensions 3 et 4

```{python}
print(fviz_pca_ind(res_pca,axis=(2,3),repel=True))
```


# Description des dimensions

On peut décrire les dimensions données par les variables en calculant le coefficient de corrélation entre une variable et une dimension et en réalisant un test de significativité.

```{python}
from scientisttools.extractfactor import get_pca_ind
row = get_pca_ind(res_pca)
print(row.keys())
```


```{python}
# Correlation Variable - Dim 1
from scipy.stats import pearsonr
corDim1 = pd.DataFrame(columns=["statistic","pvalue"]).astype("float")
for i, col in enumerate(decathlon.columns):
  if(decathlon.iloc[:,i].dtypes in ["float64","int64","float32","int32"]):
    res = pearsonr(decathlon.iloc[:,i],row["coord"]["Dim.1"])
    row_RD = pd.DataFrame({"statistic" : res.statistic,"pvalue":res.pvalue},
                          index = [col])
    corDim1 = pd.concat([corDim1,row_RD])
# Tri décroissant et significatif
corDim1 = (corDim1.query('pvalue < 0.05')
                  .sort_values(by="statistic",ascending=False))
corDim1
```

```{python}
# Correlation Variable - Dim 2
corDim2 = pd.DataFrame(columns=["statistic","pvalue"]).astype("float")
for i, col in enumerate(decathlon.columns):
  if(decathlon.iloc[:,i].dtypes in ["float64","int64","float32","int32"]):
    res = pearsonr(decathlon.iloc[:,i],row["coord"]["Dim.2"])
    row_RD = pd.DataFrame({"statistic" : res.statistic,"pvalue":res.pvalue},
                          index = [col])
    corDim2 = pd.concat([corDim2,row_RD])
# Tri décroissant et significatif
corDim2 = (corDim2.query('pvalue < 0.05')
                  .sort_values(by="statistic",ascending=False))
corDim2
```

Ces tableaux donnent le coefficient de corrélation et la probabilité critique des variables qui sont significativement corrélées aux dimensions principales. Les variables actives et illustratives dont le probabilité critique est inférieure à $0.05$ apparaissent.

Les tableaux de la description des deux axes principaux montrent que les variables "Points" et "Long\_jump" sont les plus corrélées à la première dimension et que "Discus" est la variable la plus corrélée à la deuxième dimension. Ceci confirme la premièer interprétation.

Si on ne veut pas qu'un (ou plusieurs) individu participe à l'analyse, il est possible de l'ajouter en tant qu'individu illustratif. Ainsi, il ne sera pas actif dans l'analyse mais apportera de l'information supplémentaire.

Pour ajouter des individus illustratifs, utilisez l'argument suivant de la fonction PCA :

```{python,eval=FALSE}
row_sup_labels
```

Tous les résultats détaillés peuvent être vus dans l'objet \texttt{res\_pca}. On peut récupérer les valeurs propres, les résultats des individus actifs et illustratifs, les résultats des variables actives et les résultats des variables continues et qualitatives illustratives en tapant :

```{python}
from scientisttools.extractfactor import get_pca_ind,get_pca_var,get_eig
eig = get_eig(res_pca)
```

```{python}
row = get_pca_ind(res_pca)
print(row.keys())
```

```{python}
var = get_pca_var(res_pca)
print(var.keys())
```

# Interprétation des axes

Des graphiques qui permettent d'interpréter rapidement les axes : on choisit un axe factoriel (le 1er axe dans notre exemple) et on observe quels sont les points lignes et colonnes qui présentent les plus fortes contributions et cos2 pour cet axe.

```{python, out.width="90%"}
# Classement des points lignes en fonction de leur contribution au 1er axe
from scientisttools.ggplot import fviz_contrib, fviz_cosines
print(fviz_contrib(res_pca,choice="ind",axis=0,top_contrib=10))
```

```{python,out.width="90%"}
# Classement des points colonnes en fonction de leur contribution au 1er axe
print(fviz_contrib(res_pca,choice="var",axis=0))
```

```{python,out.width="85%"}
# Classement des points lignes en fonction de leur cos2 sur le 1er axe
print(fviz_cosines(res_pca,choice="ind",axis=0,top_cos2=10))
```

```{python,out.width="85%"}
# Classement des points colonnes en fonction de leur cos2 sur le 1er axe
print(fviz_cosines(res_pca,choice="var",axis=0))
```

# Approche Machine Learning

Ici, l'objectif est d'utiliser l'Analyse en Composantes Principales en tant que méthode de prétraitement.

La classe PCA implémente les méthodes \texttt{fit}, \texttt{transform} et \texttt{fit\_transform} bien connues des utilisateurs de scikit-learn.

```{python}
res_pca.transform(actif)[:5,:]
```


```{python}
res_pca.fit_transform(decathlon)[:5,:]
```


## Intégration dans une Pipeline de scikit-learn

La class PCA peut être intégrée dans une Pipeline de scikit-learn.
Dans le cadre de notre exemple, nous cherchons à prédire la 13ème variable (variable "Competition") à partir des 12 premières variables du jeu de données. 

"Competition" est une variable catégorielle binaire. Pour la prédire, nous allons utiliser un modèle de régression logistique qui prendra en input des axes issus d'une Analyse en Composantes Principales pratiquée sur les données brutes.

Dans un premier temps, et de façon tout à fait arbitraire, nous fixons le nombre de composantes extraites à 4.

```{python}
from sklearn.pipeline import Pipeline
from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import GridSearchCV
import numpy as np

# X = features
X = decathlon.drop(columns=["Competition"])
# y = labels
y = decathlon[["Competition"]]

# Construction de la Pipeline
# On enchaine une Analyse en Composantes Prnicipales (4 axes retenus) 
# puis une régression logistique
pipe = Pipeline([("pca", PCA(n_components=4)), 
                 ("logistic_regression", LogisticRegression(penalty=None))])
# Estimation du modèle
pipe.fit(X, y)
```

On prédit

```{python}
# Prédiction sur l'échantillon de test
print(pipe.predict(X))
```


Le paramètre \texttt{n\_components} peut faire l'objet d'une optimisation via GridSearchCV de scikit-learn.

Nous reconstruisons donc une Pipeline, sans spécifier de valeur a priori pour n_components.

```{python}
# Reconstruction d'une Pipeline, sans spécifier de valeur 
# a priori pour n_components
pipe2 = Pipeline([("pca", PCA()), 
                  ("logistic_regression", LogisticRegression(penalty=None))])
                  
# Paramétrage de la grille de paramètres
# Attention à l'étendue des valeurs possibles pour pca__n_components !!!
param = [{"pca__n_components": [x + 1 for x in range(12)]}]

# Construction de l'obet GridSearchCV
grid_search = GridSearchCV(pipe2, 
                           param_grid=param, 
                           scoring="accuracy",
                           cv=5,
                           verbose=0)
# Estimation du modèle
grid_search.fit(X, y)
```


```{python}
# Affichage du score optimal
grid_search.best_score_
```


```{python}
# Affichage du paramètre optimal
grid_search.best_params_
```

```{python}
# Prédiction sur l'échantillon de test
grid_search.predict(X)
```



Pour plus d'informations sur l'ACP sous scientisttools, consulter le notebook 

\href{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/pca_example.ipynb}{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/pca\_example.ipynb}.

---
title: '**AFC sous Python avec scientisttools**'
author: "Duvérier DJIFACK ZEBAZE"
#date: "`r Sys.Date()`"
documentclass: article
geometry: "left=2.5cm,right=2.5cm,top=2.5cm,bottom=2.5cm, twoside=true"
fontsize: 11pt
line-height: 1.5
urlcolor: blue
linkcolor: blue
link-citations : yes
output: pdf_document
mainfont: Bookman Old Style
header-includes:
- \usepackage{pbox}
- \usepackage{caption}
- \usepackage{subcaption}
- \usepackage{natbib}
- \usepackage[utf8]{inputenc} # Caractères spéciaux
- \usepackage[french]{babel}
- \usepackage{amsmath, amsfonts, amssymb}   #Symboles mathématiques
- \usepackage{amsfonts}
# - \usepackage{minitoc} # [undotted] pour supprimer les pointillés
# - \mtcsetdepth{minitoc}{1} # 1 section, 2 sous-section 3 sous-sous-section
# - \mtcsettitle{minitoc}{Sommaire} # Changer le titre
- \usepackage{diagbox}
- \usepackage{lettrine}
- \usepackage[labelfont=bf]{caption}
- \captionsetup{font=scriptsize}
- \usepackage{booktabs}
- \usepackage{longtable}
- \usepackage{array}
- \usepackage{multirow}
- \usepackage{wrapfig}
- \usepackage{float}
- \usepackage{colortbl}
- \usepackage{pdflscape}
- \usepackage{tabu}
- \usepackage{threeparttable}
- \usepackage{threeparttablex}
- \usepackage[normalem]{ulem}
- \usepackage{makecell}
- \usepackage{xcolor}
- \usepackage{minitoc}
- \usepackage[Bjornstrup]{fncychap}
#- \usepackage[Conny]{fncychap} 
#- \usepackage[pdftex]{pict2e}
- \usepackage[dvipsnames]{xcolor}
- \usepackage{fourier-orns}
- \usepackage{fancyhdr}
- \usepackage{geometry}
- \geometry{a4paper,total={160mm,240mm},left=25mm,right=25mm,top=25mm,bottom=25mm}
- \usepackage[printsolution=true]{exercises}
- \usepackage{tikz}
---

```{r setup, include=FALSE}
library(reticulate)
library(knitr)
library(kableExtra)
knitr::opts_chunk$set(echo = TRUE,message=FALSE, warning=FALSE,fig.pos = "H",
                      out.extra = "",fig.align = "center",collapse =  FALSE,
                      highlight = TRUE)
```

Ce tutoriel a pour objectif de présenter rapidement les principales fonctionnalités offertes par le package \og scientisttools \fg{} pour réaliser une Analyse Factorielle des Correspondances. 

# Présentation des données

Les données sur lesquelles nous allons travailler proviennent du site \href{http://factominer.free.fr/factomethods/analyse-factorielle-des-correspondances.html}{http://factominer.free.fr/factomethods/analyse-factorielle-des-correspondances.html}. Il s'agit des données issues d'un questionnaire réalisé sur des françaises en $1974$.

Ces données sont issues d'une enquête du CREDOC publiée en 1974 par Nicole Tabard, intitulée Besoins et aspirations des familles et des jeunes. $1724$ femmes ont répondu à différentes questions à propos du travail des femmes, parmi lesquelles : 

\begin{enumerate}
\item Quelle est selon vous la famille parfaite?
\begin{itemize}
\item  L'homme et la femme travaillent
\item L'homme travaille plus que la femme
\item Seul l'homme travaille
\end{itemize}
\item Quelle activité est la meilleure pour une mère quand les enfants vont à l'école?
\begin{itemize}
\item Rester à la maison
\item Travailler à mi - temps
\item Travailler à temps complet
\end{itemize}
\item Que pensez - vous de la phrase suivante : les femmes qui ne travaillent pas se sentent coupées du monde?
\begin{itemize}
\item Complètement d'accord
\item Plutôt d'accord
\item Plutôt en désaccord
\item Complètement en désaccord
\end{itemize}
\end{enumerate}

Le tableau de données est formé de deux tableaux de contingence qui croisent les réponses de la première question à celles des deux autres. 

Nous pouvons charger les données sur \href{http://factominer.free.fr/factomethods/datasets/women_work.txt}{http://factominer.free.fr/factomethods/datasets/women\_work.txt}


```{python}
# Chargement des données
import pandas as pd
url = "http://factominer.free.fr/factomethods/datasets/women_work.txt"
women_work = pd.read_table(url,header=0)
women_work.info()
```


```{r women-work-data,engine='R',echo=FALSE}
knitr::kable(py$women_work, 
             caption = "Données d'enquête",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::row_spec(0,angle = 90) %>% 
  kableExtra::column_spec(c(1,4,8),border_right = TRUE) %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Chaque valeur du tableau \ref{tab:women-work-data} correspond au nombre de femmes ayant donnée la réponse en ligne et la réponse en colonne.

Le point de départ de l’analyse est le tableau de contingence reproduit ci-dessous. 

```{r,engine='R',echo=FALSE}
knitr::kable(py$women_work[,c(1:3)], 
             caption = "Données d'enquête",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

C’est ce type de données (les marges des totaux mis à part) que nous fournirons à la fonction de calcul de l’AFC.

Comme le souligne François Husson dans le MOOC Analyse des données multidimensionnelles sur la plateforme FUN, il est difficile de savoir à partir de ce tableau si les femmes sont favorables ou non au travail féminin. En effet, 908 femmes sur $1 724$, soit $52\%$ ont répondu que la famille idéale est celle où \og Only man works \fg{}. Elles sont néanmoins $1 123$ sur $1 724$ $(65\%)$ à avoir répondu que l’activité convenant le mieux à une mère de famille quand ses enfants vont à l’école est de travailler à mi-temps \og part-time work \fg{}. L’AFC va nous permettre d’étudier le lien entre ces deux questions et de lever cette apparente contradiction. Elle va notamment nous permettre de visualiser la nature de la liaison entre les deux questions. Mais qu’est ce qu’une liaison ?

Une liaison entre deux variables est l’écart entre les données observées et le modèle d’indépendance. Mettons pour l’instant de côté cette notion, nous y reviendrons plus tard.

# Objectifs 

Les objectifs de l'AFC sont similaires à ceux de l'ACP : obtenir une typologie des lignes et des colonnes et étudier le lien entre ces deux typologies.

Cependant, le concept de similarité entre les lignes et les colonnes est diférent. Ici, la similarité entre deux lignes ou deux colonnes est complètement symétrique. Deux lignes (resp. colonnes) sont proches l'une de l'autre si elles s'associent aux colonnes (resp. lignes) de la même façon.

On recherche les lignes (resp. colonnes) dont la distribution est la plus différente de celle de la population. Celles qui semblent le plus ou le moins semblables.

Chaque groupe de lignes (resp. colonnes) est caractérisé par les colonnes (resp. lignes) auxquelles il est particulièrement ou particulièrement peu associé.

Nous travaillons d'abord avec seulement les 3 premières colonnes: \og Stay at home \fg{}, \og Part time work \fg{} et \og Full time work \fg{}.

```{python}
# Selection des 3 premières colonnes
wfemmes = women_work.iloc[:,:3]
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$wfemmes, 
             caption = "Données d'enquête - Tableau des données observées",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Notons que nous pouvons calculer les marges lignes et les marges colonnes de ce tableau de contingence de la manière suivante : 

```{python}
# Ajout des marges lignes et colonnes
wfemmes_avec_marges = wfemmes.copy()
wfemmes_avec_marges.loc["Total",:] = wfemmes.sum(axis=0)
wfemmes_avec_marges.loc[:,"Total"] = wfemmes_avec_marges.sum(axis=1)
```

```{r,engine='R',echo=FALSE}
knitr::kable(py$wfemmes_avec_marges, 
             caption = "Données d'enquête avec marge ligne et colonne",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::row_spec(3,hline_after = TRUE) %>% 
  kableExtra::column_spec(4,border_right = TRUE) %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Il est aussi intéressant de calculer les pourcentages en ligne et les pourcentages en colonne.


```{python}
# Pourcentages en ligne
import numpy as np
wfemmes_pourcentage_en_ligne = wfemmes.copy()
wfemmes_pourcentage_en_ligne.loc["Profil ligne moyen",:] = wfemmes.sum(axis=0)
wfemmes_pourcentage_en_ligne = wfemmes_pourcentage_en_ligne.apply(
                                             lambda x : 100*x/np.sum(x),axis=1)
wfemmes_pourcentage_en_ligne.loc[:,"Total"] = wfemmes_pourcentage_en_ligne.sum(
                                                       axis=1)
```

```{r,engine='R',echo=FALSE}
knitr::kable(round(py$wfemmes_pourcentage_en_ligne,2), 
             caption = "Données d'enquête - Tableau des pourcentages en ligne",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::row_spec(3,hline_after = TRUE) %>% 
  kableExtra::column_spec(4,border_right = TRUE) %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Pour rappel, la ligne \og Profil ligne moyen \fg{} correspond à la répartition en pourcentage des modalités à la question sur \og l’activité qui convient le mieux à une mère de famille quand les enfants vont à l’école \fg{}, quelque soit la réponse à la question sur la famille idéale. Le profil ligne moyen peut être comparé aux profils lignes (la répartition en pourcentages ou la distribution de probabilité d’une modalité en ligne). Ici, aucun des trois profils lignes n’est proche du profil ligne moyen.

Calculons maintenant le tableau des pourcentages en colonne

```{python}
# Pourcentage en colonne
wfemmes_pourcentage_en_colonne = wfemmes.copy()
wfemmes_pourcentage_en_colonne.loc[:,"Profil colonne moyen"] = wfemmes.sum(axis=1)
wfemmes_pourcentage_en_colonne = wfemmes_pourcentage_en_colonne.apply(
                                             lambda x : 100*x/np.sum(x),axis=0)
wfemmes_pourcentage_en_colonne.loc["Total",:] = wfemmes_pourcentage_en_colonne.sum(
                                                       axis=0)
```


```{r,engine='R',echo=FALSE}
knitr::kable(round(py$wfemmes_pourcentage_en_colonne,2), 
             caption = "Données d'enquête - Tableau des pourcentages en colonne",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::row_spec(3,hline_after = TRUE) %>% 
  kableExtra::column_spec(4,border_right = TRUE) %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Ce tableau permet de constater que la répartition des réponses sur la famille idéale pour la modalité \og Part-time work \fg{} est le plus proche de la répartion des réponses à la question sur la famille idéale. Autrement dit, le profil colonne \og Part-time work \fg{} est le profil colonne le plus proche du profil colonne moyen. Cette similitude se traduira sur le graphe de l’AFC comme nous le verrons plus loin.

Nous verrons également que l’on passera en paramètre à la fonction Python de calcul de l’AFC, le tableau de contingence. Mais l’AFC travaille en réalité sur le tableau de probabilités que l’on peut calculer en divisant les valeurs du tableau de contingence par le nombre d’individus (on effectue le calcul sur le tableau de contingence avec marge pour mieux constater que l’effectif total du tableau de probabilité est bien égal à 1, ce qui est la marque d’une distribution de probabilités) :

```{python}
# Tableau des probabilités
wfemmes_tableau_de_probabilite = wfemmes_avec_marges/1724
```

```{r,engine='R',echo=FALSE}
knitr::kable(round(py$wfemmes_tableau_de_probabilite,5), 
             caption = "Données d'enquête - Tableau de probabilité",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::row_spec(3,hline_after = TRUE) %>% 
  kableExtra::column_spec(4,border_right = TRUE) %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Rappellons que notre objectif est de visualiser la nature de la liaison entre deux variables qualitatives. Mais faut-il encore que cette liaison soit significative. Pour ce faire, nous réalisons un test du Khi2.

## Test du $\chi^{2}$

Le test du $\chi^{2}$ mesure la significativité d’une liaison mais pas son intensité. Afin de réaliser ce test du $\chi^{2}$, nous utilisons la fonction \href{https://docs.scipy.org/doc/scipy/reference/generated/scipy.stats.chi2_contingency.html}{chi\_contingency} de scipy.

```{python}
# Test de contingence du chi2
import scipy.stats as st
stat, pvalue, dof, expected = st.chi2_contingency(wfemmes)
chisq_test = pd.DataFrame({"statistic":stat,"dof":dof,"pvalue":pvalue},
                          index=["chi2 - test"])
print(chisq_test)
```

La fonction \href{https://docs.scipy.org/doc/scipy/reference/generated/scipy.stats.chi2_contingency.html}{chi\_contingency} nous donne, entre autres, la valeur du $\chi^{2}$ qui est un indicateur de la significativité de la liaison. Mais ce qui nous interesse ici est la p-value. Nous voyons ici que la p-value est égale à `r py$pvalue`. Cela signifie que la probabilité que les variables soient indépendantes est égale à `r py$pvalue`. Ce qui nous permet de rejeter l’hypothèse d’indépendance entre les deux variables. Pour autant, cela ne veut pas dire que les variables soient dépendantes. Les réponses à la question sur la famille idéale sont probablement liées aux réponses concernant l’activité convenant le mieux à une mère de famille dont les enfants vont à l’école.

## Test de $\chi^{2}$ - Explications

Le test du $\chi^{2}$ permet de déterminer la probabilité que les deux variables d’un tableau de contingence soient indépendantes, c’est-à-dire qu’il n’existe pas de relation entre les modalités en ligne et les modalités en colonne (les unes ne conditionnent pas les autres, et réciproquement). Dit autrement et comme le rappelle très clairement Julien Barnier, cela veut dire que le \og fait d’appartenir à une modalité de la première variable n’a pas d’influence sur la modalité d’appartenance de la deuxième variable \fg{}. Dans ce test, l’hypothèse nulle (H0) suppose qu’il y a indépendance entre les deux variables. Si nous acceptons l’hypothèse d’indépendance (H0), nous n’aurons pas d’utilité à réaliser une AFC car les points projetés seront extrêmement proches ou confondus avec le centre de gravité, confondus avec le centre du graphe. Si nous rejetons l’hypothèse d’indépendance (p-value $< 0,05$), l’hypothèse alternative (H1) suppose que la liaison entre les deux variables est significative sans que nous puissions définir l’intensité de la liaison.

Rappelons que pour que le test du $\chi^{2}$ soit opératoire, il doit respecter un certain nombre de conditions (pour reprendre les propos de Claude Grasland) :
\begin{itemize}
\item L’effectif total du tableau de contingence doit être supérieur ou égal à $20$.
\item L’effectif marginal du tableau de contingence doit toujours être supérieur ou égal à $5$.
\item L’effectif théorique des cases du tableau de contingence doit être supérieur à $5$ dans $80\%$ des cases du tableau de contingence.
\end{itemize}

Du fait que nous ayons obtenu une p-value égale à `r py$pvalue` et, par extension, inférieure au seuil de $0,05$, nous rejetons l’hypothèse d’indépendance entre les deux variables.

## Test du $\chi^{2}$ - Aide à l'interprétation

Le test du $\chi^{2}$ est symétrique. Les lignes et les colonnes du tableau croisé sont interchangeables. Le résultat du test sera exactement le même. Il n’y a pas de \og sens de lecture \fg{} du tableau.

Nous pouvons afficher le tableau d’indépendance (tableau des effectifs théoriques) en sélectionnant la valeur \texttt{expected}. Dans ce contexte, nous calculons le tableau des pourcentages théoriques, en multipliant pour chaque case la proportion observée dans la population des deux modalités correspondantes. Puis, le tableau des effectifs théoriques se calcule en multipliant le tableau des pourcentages théoriques par l’effectif total.

```{python}
# Tableau des effectifs théoriques
effectif_theorik = pd.DataFrame(expected,index=wfemmes.index,
                                columns=wfemmes.columns)
```

```{r,engine='R',echo=FALSE}
knitr::kable(round(py$effectif_theorik,5), 
             caption = "Données d'enquête - Tableau des effectifs théoriques",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Le tableau des effectifs théoriques n’a que peu d’intérêt en lui-même mais en a davantage comparativement au tableau des données observées.

Nous pouvons aussi afficher le tableau des résidus standardisés (tableau des écarts à l’indépendance). Un résidu standardisé positif signifie que les effectifs dans la case sont supérieur à ceux attendus sous l’hypothèse d’indépendance. Et l’inverse pour un résidu standardisé négatif.

```{python}
# Residus standardisés
standardized_residuals = (wfemmes - effectif_theorik)/np.sqrt(effectif_theorik)
```

```{r,engine='R',echo=FALSE}
knitr::kable(round(py$standardized_residuals,5), 
             caption = "Données d'enquête - Résidus standardisés",
             booktabs = TRUE,linesep = "") %>% 
  kableExtra::kable_styling(font_size=8,position="center",
                            latex_options = c("striped", "hold_position","repeat_header"))
```

Exprimé d’une autre manière, l’écart à l’indépendance représente l’écart entre l’effectif observé et l’effectif théorique, et ceci pour chacune des cases du tableau de contingence. D’ailleurs, comme le note Philippe Cibois, l’écart à l’indépendance \og est un effectif et c’est un invariant, indépendant du choix des lignes et des colonnes (c’est la différence entre l’effectif observé et l’effectif théorique : le résultat est donc un effectif). \fg{}
Par ailleurs,
\begin{itemize}
\item Un écart à l’indépendance positif correspond à une attraction entre les deux modalités pour la case observée.
\item À l’inverse, un écart à l’indépendance négatif correspond à une opposition entre les deux modalités pour la case observée.
\end{itemize}

Plus la valeur de l’écart à l’indépendance est importante, plus l’attraction/opposition entre les modalités est forte.

# AFC

Notre objectif est bien de visualiser la nature de la liaison entre les deux variables qualitatives. Sachant qu’une liaison correspond à l’écart entre les données observées et le modèle d’indépendance, nous souhaitons donc visualiser la nature de l’écart à l’indépendance entre deux variables qualitatives.

Par ailleurs, il y a trois façons de caractériser la liaison entre les deux variables qualitatives.
\begin{itemize}
\item La significativité de la liaison (qui se mesure avec le test du $\chi^{2}$).
\item L’intensité de la liaison (qui se mesure, entre autre, avec le $\phi^{2}$).
\item La nature de la liaison (qui correspond à l’association entre les modalités et qui est représentée par le biais de l’AFC).
\end{itemize}

Le test du $\chi^{2}$ a permis d’écarter l’hypothèse d’indépendance. Il y a donc une liaison entre les modalités des deux variables. De fait, nous pouvons faire une AFC pour visualiser la nature de la liaison. Pour notre part, nous avons choisi d’utiliser le package \og scientisttools \fg{} (dédié à l’analyse multidimensionnelle de données).

On utilisera les trois première colonnes (correspondant aux réponses de la deuxième question) comme variables actives et les quatre dernières (correspondant à la troisième question) comme variables illustratives.

Nous chargeons donc la librairie \og scientisttools \fg{}

```{python}
# Chargement de la librairie
from scientisttools.decomposition import CA
```


## Lignes et colonnes actives seulement

Lors du précédent test du $\chi^{2}$, nous avons obtenu une p-value égale à `r py$pvalue`. Nous avons donc rejeté l'hypothèse d'indépendance entre les deux variables et admis que la liaison entre ces deux variables est significative. Nous sommes en droit de réaliser une AFC afin de visualiser la nature de la liaison. Pour ce faire, nous allons employer la fonction \texttt{CA}, fournie par le package \og scientisttools \fg{}.

On crée une instance de la classe CA, en lui passant ici des étiquettes pour les lignes et les colonnes. Ces paramètres sont facultatifs ; en leur absence, le programme détermine automatiquement des étiquettes.

```{python}
# Instanciation du modèle
my_ca = CA(n_components=None,
           row_labels=wfemmes.index,
           col_labels=wfemmes.columns,
           row_sup_labels=None,
           col_sup_labels=None)
```

On estime le modèle en appliquant la méthode \texttt{fit} de la classe CA sur le jeu de données.

```{python}
# Entraînement - Estimation du modèle
my_ca.fit(wfemmes)
```

## Valeurs propres

L'exécution de la méthode \texttt{my\_ca.fit(wfemmes)} provoque le calcul des attributs parmi lesquels \texttt{my\_ca.eig\_} pour les valeurs propres.

```{python}
# Valeurs propres
print(my_ca.eig_)
```

L'attribut \texttt{my\_ca.eig\_} contient :

\begin{itemize}
\item en 1ère ligne : les valeurs propres en valeur absolue
\item en 2ème ligne : les différences des valeurs propres
\item en 3ème ligne : les valeurs propres en pourcentage de la variance totale (proportions)
\item en 4ème ligne : les valeurs propres en pourcentage cumulé de la variance totale.
\end{itemize}

La fonction \texttt{get\_eig} retourne les valeurs propres sous forme de tableau de données.

```{python}
# Valeurs propres
from scientisttools.extractfactor import get_eig
print(get_eig(my_ca))
```

Les valeurs propres peuvent être représentées graphiquement

```{python, out.width="90%"}
from scientisttools.ggplot import fviz_eigenvalue
print(fviz_eigenvalue(my_ca,choice="eigenvalue"))
```

```{python, out.width="90%"}
print(fviz_eigenvalue(my_ca,choice="proportion"))
```

On peut obtenir un résumé des principaux résultats en utilisant la fonction \texttt{summaryCA}.

```{python}
from scientisttools.extractfactor import summaryCA
summaryCA(my_ca)
```

Cette fonction \texttt{summaryCA} nous permet d'obtenir :

\begin{itemize}
\item Un tableau avec les valeurs propres, les différences, les pourcentages et les pourcentages cumulés d'inertie associés à chaque dimension.
\item Un tableau avec les résultats sur les lignes actives avec leur coordonnées (Dim.n) sur chaque dimension, leur contribution à la construction (ctr) de chaque dimension et leur qualité de représentation (cos2) sur chaque dimension.
\item Un tableau avec les résultats sur les colonnes actives (Dim.n, ctr, cos2)
\end{itemize}

## Représentation graphique

```{python,out.width="90%"}
# Carte des points lignes
from scientisttools.ggplot import fviz_ca_row
print(fviz_ca_row(my_ca,color="blue",repel=True))
```

```{python, out.width="90%"}
# Carte des points colonnes
from scientisttools.ggplot import fviz_ca_col
print(fviz_ca_col(my_ca,color="red",repel=True))
```


Le nuage des colonnes montre que le premier axe oppose \og Stay at home \fg{} et \og Full-time work \fg{}, ce qui signifie qu'il oppose deux profils de femmes. Les femmes qui ont répondu \og Stay at home \fg{} ont répondu \og Only husband works \fg{} plus souvent que l'ensemble de la population et \og Both husband and wife work \fg{} moins souvent que l'ensemble de la population.

De même, les femmes qui ont répondu \og Full-time work \fg{} ont répondu \og Only husband works \fg{} moins souvent que l'ensemble de la population et \og Both husband and wife work \fg{} plus souvent que l'ensemble de la population. Le premier axe ordonne les modalités de la deuxième question de la moins à la plus en faveur du travail des femmes.

La même interprétation peut être faite pour le premier axe du nuage des lignes. Les modalités sont triées de la moins (\og Only husband works \fg{}) à la plus (\og Both husband and wife work\fg{}) en faveur du travail des femmes.

On peut représenter à la fois les lignes et les colonnes.

```{python,echo=FALSE}
from fanalysis.ca import CA
my_ca_fa = CA(n_components=None,
               row_labels=wfemmes.index,
               col_labels=wfemmes.columns).fit(wfemmes.values)
my_ca_fa.mapping(num_x_axis=1, num_y_axis=2)
```


\og Stay at home \fg{} est associé à \og Only husband works \fg{} et peu associé aux deux autres modalités.

\og Both husband and wife work \fg{} est associé à \og Full-time work \fg{} et opposé à \og Stay at home \fg{}.

Revenons un instant sur les données du tableau \ref{tab:women-work-data}, issu de l'enquête de Nicole Tabard, croisant les deux variables qualitatives (questions) :

\begin{itemize}
\item Quelle est la famille idéale pour vous?
\item Quelle activité convient le mieux à une mère de famille quand ses enfants vont à l'école?
\end{itemize}

Il est important de rappeler que les résultats de cette enquête ont été publiés en $1974$. Il est fort à parier que la répartition des réponses serait totalement, si ce n’est en grande partie, différente aujourd’hui.

Lors d’une première lecture de ce tableau de contingence, François Husson soulève une apparente contradiction. À la question \og Quelle est la famille idéale pour vous ? \fg{}, nous voyons que $908$ femmes sur $1724$ (visible dans la marge colonne), soit environ $53\%$ des répondantes, déclarent \og Only man works \fg{} et seulement $261$ femmes sur $1 724$ (environ $15\%$) déclarent \og Both man and woman work \fg{}. Sur la base de ces premières réponses, nous pouvons émettre l’hypothèse, qu’à cette époque, une majorité était en faveur d’un modèle familial où seul le mari travaille.

À côté de ça, à la question \og Quelle activité convient le mieux à une mère de famille quand ses enfants vont à l’école ? \fg{}, elles sont $1440$ sur $1724$ (visible dans la marge ligne), soit environ $84\%$, à être en faveur du travail à mi-temps \og Part time work \fg{} ou à plein-temps \og Full time work \fg{}. Les réponses à cette question semblent indiquer que les femmes sont moins hostiles au travail féminin (bien au contraire).

Du coup, à ce stade de l’interprétation, nous nous retrouvons a priori face une contradiction. De cela, nous pouvons dire que le tableau de contingence ne permet pas de savoir si les femmes des années 70 sont favorables ou non à l’activité féminine. Par contre, Une première lecture du graphe de l’AFC nous permet de dire que les modalités des réponses s’associent entre elles des plus favorables au travail féminin aux plus défavorables au travail féminin.

Avant d’approfondir, plus en détail, l’interprétation de cette AFC, nous allons faire un pas de côté et voir ce qui se passe dans le cas où il y aurait indépendance entre les deux variables.

Si nous réalisons une AFC avec les données du modèle d’indépendance, on obtient la figure suivante : 

```{python,echo=FALSE}
from fanalysis.ca import CA
my_ca_ind = CA(n_components=None,
               row_labels=effectif_theorik.index,
               col_labels=effectif_theorik.columns).fit(effectif_theorik.values)
my_ca_ind.mapping(num_x_axis=1, num_y_axis=2)
```

La lecture de ce graphique nous permet de voir que les points sont quasiment tous confondus avec le centre de gravité, correspondant au profil moyen. La représentation graphique est trompeuse mais l’échelle des axes va dans le sens de notre interprétation. Simplement, ce qu’il y a retenir de ce graphe, c’est que, lorsqu’il y a indépendance entre les deux variables, tous les points sont confondus avec l’origine. Du fait qu’il n’y ait pas d’écarts à l’indépendance, il n’y a graphiquement rien à exploiter, rien à interpréter, rien à analyser. Ce graphe donne à voir ce que nous avons précédemment énoncé, à savoir que :
\begin{itemize}
\item Si nous acceptons l’hypothèse d’indépendance (p-value $> 0.05$ dans le cas d’un test du $\chi^{2}$), nous n’aurons pas d’utilité à réaliser une AFC car les points projetés seront extrêmement proches ou confondus avec le centre de gravité, confondus avec le centre du graphe.
\item La réalisation d’un test du $\chi^{2}$ est donc fortement conseillée avant la réalisation d’une AFC.
\item Plus précisément, le test du $\chi^{2}$ conditionne l’éventuelle réalisation d’une AFC.
\end{itemize}


## Addition de colonnes illustratives

On ajoute les colonnes qui correspondent à la troisième question en tant que variables illustratives. Tapez :

```{python,echo=FALSE}
from scientisttools.decomposition import CA
```

```{python}
# Modèle avec colonnes supplémentaires
my_ca2 = CA(n_components=None,
            row_labels=women_work.index.values,
            col_labels=women_work.columns[:3].values,
            row_sup_labels=None,
            col_sup_labels=women_work.columns[3:].values).fit(women_work)
```


```{python}
# Carte de modalités colonnes
import matplotlib.pyplot as plt
from scientisttools.pyplot import plotCA
fig,axe = plt.subplots(figsize=(10,10))
plotCA(my_ca2,choice ="col",add_sup=True,color="blue",repel=True,ax=axe)
plt.show()
```

\og Totally agree \fg{} et \og Quite agree \fg{} pour \og Women who do not work feel cut off from the world \fg{} sont proches des modalités en faveur du travail des femmes.

\og Quite disagree \fg{} et \og Totally "disagree \fg{} sont proches des modalités opposées au travail des femmes.

Pour ajouter des points lignes illustratifs, utilisez l'argument suivant de la fonction PCA :

```{python,eval=FALSE}
row_sup_labels
```

Tous les résultats détaillés peuvent être vus dans l'objet \texttt{my\_pca2}. On peut récupérer les valeurs propres, les résultats des points lignes actifs et illustratifs, les résultats des points colonnes actifs et supplémentaires en tapant :

```{python}
from scientisttools.extractfactor import get_ca_row,get_ca_col,get_eig
eig = get_eig(my_ca2)
```

```{python}
row = get_ca_row(my_ca2)
print(row.keys())
```

```{python}
col = get_ca_col(my_ca2)
print(col.keys())
```

## Interprétation des axes

Des graphiques qui permettent d'interpréter rapidement les axes : on choisit un axe factoriel (le 1er axe dans notre exemple) et on observe quels sont les points lignes et colonnes qui présentent les plus fortes contributions et cos2 pour cet axe.

```{python, out.width="90%"}
# Classement des points lignes en fonction de leur contribution au 1er axe
from scientisttools.pyplot import plot_contrib, plot_cosines
fig,axe = plt.subplots(figsize=(16,10))
plot_contrib(my_ca,choice="ind",axis=0,top_contrib=10,ax=axe)
plt.show()
```

```{python,out.width="90%"}
# Classement des points colonnes en fonction de leur contribution au 1er axe
fig,axe = plt.subplots(figsize=(16,10))
plot_contrib(my_ca2,choice="var",axis=0,ax=axe)
plt.show()
```

```{python,out.width="85%"}
# Classement des points lignes en fonction de leur cos2 sur le 1er axe
fig,axe = plt.subplots(figsize=(16,10))
plot_cosines(my_ca2,choice="ind",axis=0,top_cos2=10,ax=axe)
plt.show()
```

```{python,out.width="85%"}
# Classement des points colonnes en fonction de leur cos2 sur le 1er axe
fig,axe = plt.subplots(figsize=(16,10))
plot_cosines(my_ca2,choice="var",axis=0,ax=axe)
plt.show()
```

Pour plus d'informations sur l'ACF sous scientisttools, consulter le notebook 

\href{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/ca_example2.ipynb}{https://github.com/enfantbenidedieu/scientisttools/blob/master/notebooks/ca\_example2.ipynb}
